
/*-------- begin ../sfi/sfidl generated code --------*/



#include <bse/bsecxxplugin.hh>


/* enum prototypes */


/* choice prototypes */


/* record prototypes */


/* sequence prototypes */


/* class prototypes */
namespace Bse {
namespace Arts {
class CompressorBase;
class Compressor;
#define BSE_ARTS_TYPE_COMPRESSOR		BSE_CXX_DECLARED_CLASS_TYPE (Bse::Arts, Compressor)
#define BSE_ARTS_IS_COMPRESSOR(o) (::Bse::CxxBase::instance_is_a (o, BSE_ARTS_TYPE_COMPRESSOR))


/* enum definitions */


/* sequence definitions */


/* record definitions */


/* enum declarations */


/* sequence type declarations */


/* record type declarations */


/* procedure prototypes */


/* class definitions */
BSE_CXX_DECLARE_CLASS (Compressor);
class CompressorBase : public ::Bse::Effect {
  template<bool> static inline const unsigned char* inlined_pixstream();
public:
  static inline const unsigned char* pixstream () { return inlined_pixstream<true>(); }
  static void               class_init (::Bse::CxxBaseClass *klass);
  static inline const char* options   () { return ""; }
  static inline const char* category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules",  ("/Enhance/ArtsCompressor")); }
  static inline const char* i18n_category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules", _("/Enhance/ArtsCompressor")); }
  static inline const char* blurb     () { return _("ArtsCompressor compresses the sound.\n\nCompression is a dynamic operation that consists of two parts:\n(1) the current input volume of the signal is detected\n(2) if it exceeds a given theshold, the volume of the output signal will be reduced\n\nThe input volume detection has an attack and a release half-life time which can be specified - in milliseconds - with the corresponding properties. This envelope causes the compressor to adapt slowly to the actual input signal level.\n\nThe ratio specifies how the volume of a signal should be reduced, if it exceeds the threshold. A compression ratio of 2:1 means for instance that if the input volume is 2 dB over the threshold, the output volume will be 1 dB over the threshold. Example (threshold = -10, ratio 2:1):\ninput = -20 dB => output = -20 dB\ninput = -10 dB => output = -10 dB\ninput = 0 dB => output = -5 dB\ninput = 10 dB => output = 0 dB\ninput = 20 dB => output = 5 dB\n\nCompression is often thought off as an operation to make music \"sound louder\". To achieve this, the first step is to reduce the dynamic range like in the example above. As the loud parts of the music have been reduced in volume, we can now amplify everything, without risking distortion or clipping. This has the overall effect of the music sounding louder. In our example, an output amplification of 5 dB would be okay, if the input signal never exceeded 0 dB."); }
  static inline const char* authors   () { return "Matthias Kretz, Stefan Westerfeld"; }
  static inline const char* license   () { return _("GNU General Public License"); }
  static inline const char* type_name () { return "BseArtsCompressor"; }
public:
  enum {
    ICHANNEL_AUDIO_IN1,
    ICHANNEL_AUDIO_IN2,
    N_ICHANNELS
  };
public:
  enum {
    OCHANNEL_AUDIO_OUT1,
    OCHANNEL_AUDIO_OUT2,
    N_OCHANNELS
  };
protected:
  enum CompressorPropertyID {
    PROP_ATTACK = 1,
    PROP_RELEASE,
    PROP_THRESHOLD_DB,
    PROP_RATIO_TO_ONE,
    PROP_OUTPUT_DB,
    PROP_AUTO_OUTPUT,
    PROP_THRESHOLD,
    PROP_RATIO,
    PROP_OUTPUT,
  };
public:
  /* "transport" structure to configure synthesis modules from properties */
  struct CompressorProperties {
    typedef CompressorPropertyID IDType;
    Sfi::Real attack;
    Sfi::Real release;
    Sfi::Real threshold_db;
    Sfi::Real ratio_to_one;
    Sfi::Real output_db;
    bool auto_output;
    Sfi::Real threshold;
    Sfi::Real ratio;
    Sfi::Real output;
    explicit CompressorProperties (CompressorBase *p) :
      attack (p->attack),
      release (p->release),
      threshold_db (p->threshold_db),
      ratio_to_one (p->ratio_to_one),
      output_db (p->output_db),
      auto_output (p->auto_output),
      threshold (p->threshold),
      ratio (p->ratio),
      output (p->output)
    {
    }
  };
protected:
  typedef void AutoUpdateCategory;
protected:
  Sfi::Real attack;
  Sfi::Real release;
  Sfi::Real threshold_db;
  Sfi::Real ratio_to_one;
  Sfi::Real output_db;
  bool auto_output;
  Sfi::Real threshold;
  Sfi::Real ratio;
  Sfi::Real output;
public:
  void get_property (CompressorPropertyID prop_id, ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_ATTACK:
      sfi_value_set_real (&value, attack);
    break;
    case PROP_RELEASE:
      sfi_value_set_real (&value, release);
    break;
    case PROP_THRESHOLD_DB:
      sfi_value_set_real (&value, threshold_db);
    break;
    case PROP_RATIO_TO_ONE:
      sfi_value_set_real (&value, ratio_to_one);
    break;
    case PROP_OUTPUT_DB:
      sfi_value_set_real (&value, output_db);
    break;
    case PROP_AUTO_OUTPUT:
      sfi_value_set_bool (&value, auto_output);
    break;
    case PROP_THRESHOLD:
      sfi_value_set_real (&value, threshold);
    break;
    case PROP_RATIO:
      sfi_value_set_real (&value, ratio);
    break;
    case PROP_OUTPUT:
      sfi_value_set_real (&value, output);
    break;
    };
  }
  void set_property (CompressorPropertyID prop_id, const ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_ATTACK:
      attack = sfi_value_get_real (&value);
    break;
    case PROP_RELEASE:
      release = sfi_value_get_real (&value);
    break;
    case PROP_THRESHOLD_DB:
      threshold_db = sfi_value_get_real (&value);
    break;
    case PROP_RATIO_TO_ONE:
      ratio_to_one = sfi_value_get_real (&value);
    break;
    case PROP_OUTPUT_DB:
      output_db = sfi_value_get_real (&value);
    break;
    case PROP_AUTO_OUTPUT:
      auto_output = sfi_value_get_bool (&value);
    break;
    case PROP_THRESHOLD:
      threshold = sfi_value_get_real (&value);
    break;
    case PROP_RATIO:
      ratio = sfi_value_get_real (&value);
    break;
    case PROP_OUTPUT:
      output = sfi_value_get_real (&value);
    break;
    };
    property_changed (CompressorPropertyID (prop_id));
    update_modules();
    switch (prop_id) {
    default: ;
    };
  }
  virtual bool editable_property (CompressorPropertyID prop_id, GParamSpec *pspec)
  {
    return true;
  }
  virtual void get_candidates (CompressorPropertyID prop_id, ::Bse::PropertyCandidatesHandle &pch, GParamSpec *pspec)
  {
  }
  void property_updated (CompressorPropertyID prop_id, guint64 tick_stamp, double prop_value, GParamSpec *pspec)
  {
    bool seen_change = false;
    switch (prop_id) {
    default: ;
    };
    if (seen_change &&
        property_changed (CompressorPropertyID (prop_id)))
      update_modules();
  }
private:
  static struct StaticData {
    int dummy;
  } static_data;
protected:
  virtual bool property_changed (CompressorPropertyID) { return false; }
  virtual ~CompressorBase ()
  {
  }
public:
};


/* choice implementations */


/* record implementations */


/* sequence implementations */


/* class implementations */
void
CompressorBase::class_init (::Bse::CxxBaseClass *klass)
{
  klass->set_accessors (::Bse::cxx_get_property_trampoline<CompressorBase, CompressorPropertyID>,
                        ::Bse::cxx_set_property_trampoline<CompressorBase, CompressorPropertyID>,
                        ::Bse::cxx_editable_property_trampoline<CompressorBase, CompressorPropertyID>,
                        ::Bse::cxx_get_candidates_trampoline<CompressorBase, CompressorPropertyID>,
                        NULL);
  klass->add_param (PROP_ATTACK, sfidl_pspec_Real (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/artscompressor.idl",2692,"attack",_ ( "Attack [ms]" ) , _ ( "Set the attack time in milliseconds" ) , 10 , 0.10000000000000001 , 250 , 10 , ":r:w:S:G:" ":scale"));
  klass->add_param (PROP_RELEASE, sfidl_pspec_Real (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/artscompressor.idl",2693,"release",_ ( "Release [ms]" ) , _ ( "Set the release time in milliseconds" ) , 10 , 0.10000000000000001 , 250 , 10 , ":r:w:S:G:" ":scale"));
  klass->add_param (PROP_THRESHOLD_DB, sfidl_pspec_Gain (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/artscompressor.idl",2694,"threshold_db",_ ( "Threshold [dB]" ) , _ ( "Only parts louder than threshold are compressed" ) , 0LL , - 100LL , 0LL , 1LL , ":r:w:S:G:" ":scale"));
  klass->add_param (PROP_RATIO_TO_ONE, sfidl_pspec_Real (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/artscompressor.idl",2695,"ratio_to_one",_ ( "Ratio [x:1]" ) , _ ( "Set the compression ratio to x:1" ) , 2LL , 1 , 20 , 1LL , ":r:w:S:G:" ":scale"));
  klass->add_param (PROP_OUTPUT_DB, sfidl_pspec_Gain (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/artscompressor.idl",2696,"output_db",_ ( "Output [dB]" ) , _ ( "Set the output amplification" ) , 0LL , - 20LL , 20LL , 1LL , ":r:w:S:G:" ":scale"));
  klass->add_param (PROP_AUTO_OUTPUT, sfidl_pspec_Bool (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/artscompressor.idl",2697,"auto_output",_ ( "Auto Output" ) , _ ( "Adjust the output amplification automatically according to threshold and ratio" ) , FALSE , ":r:w:G:"));
  klass->add_param (PROP_THRESHOLD, sfidl_pspec_Real ("compat","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/artscompressor.idl",2700,"threshold",NULL , NULL , 1LL , 1.0000000000000001e-05 , 1LL , 0.01 , "w"));
  klass->add_param (PROP_RATIO, sfidl_pspec_Real ("compat","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/artscompressor.idl",2701,"ratio",NULL , NULL , 0.80000000000000004 , 0 , 1 , 0.10000000000000001 , "w"));
  klass->add_param (PROP_OUTPUT, sfidl_pspec_Real ("compat","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/artscompressor.idl",2702,"output",NULL , NULL , 1LL , 0.10000000000000001 , 10 , 1LL , "w"));
  klass->add_ichannel ("audio_in1", _("Audio In1"), _("Audio input 1"), ICHANNEL_AUDIO_IN1);
  klass->add_ichannel ("audio_in2", _("Audio In2"), _("Audio input 2"), ICHANNEL_AUDIO_IN2);
  klass->add_ochannel ("audio_out1", _("Audio Out1"), _("Compressed audio output 1"), OCHANNEL_AUDIO_OUT1);
  klass->add_ochannel ("audio_out2", _("Audio Out2"), _("Compressed audio output 2"), OCHANNEL_AUDIO_OUT2);
}


/* procedure implementations */


/* artscompressor.idl type registrations */
#define BSE_CXX_REGISTER_ALL_TYPES_FROM_ARTSCOMPRESSOR_IDL() \
  BSE_CXX_REGISTER_EFFECT (Compressor); \
  /* artscompressor.idl type registrations done */
} // Arts
} // Bse
template<bool> const unsigned char*
::Bse::Arts::CompressorBase::inlined_pixstream()
{
  /* GdkPixbuf RGBA C-Source image dump 1-byte-run-length-encoded */

#ifdef __SUNPRO_C
#pragma align 4 (local_pixstream)
#endif
#ifdef __GNUC__
static const guint8 local_pixstream[] __attribute__ ((__aligned__ (4))) = 
#else
static const guint8 local_pixstream[] = 
#endif
{ ""
  /* Pixbuf magic (0x47646b50) */
  "GdkP"
  /* length: header (24) + pixel_data (5128) */
  "\0\0\24\40"
  /* pixdata_type (0x2010002) */
  "\2\1\0\2"
  /* rowstride (256) */
  "\0\0\1\0"
  /* width (64) */
  "\0\0\0@"
  /* height (64) */
  "\0\0\0@"
  /* pixel_data: */
  "\206\0\0\0\0\230\0\0\0\1\243\0\0\0\0\3\0\0\0\1\0\0\0\4\0\0\0\10\202\0"
  "\0\0\13\230\0\0\0\14\5\0\0\0\13\0\0\0\12\0\0\0\10\0\0\0\3\0\0\0\1\236"
  "\0\0\0\0\5\0\0\0\4\0\0\0\17\0\0\0\36\0\0\0(\0\0\0*\230\0\0\0,\5\0\0\0"
  "*\0\0\0&\0\0\0\32\0\0\0\12\0\0\0\2\235\0\0\0\0\7\0\0\0\1\0\0\0\10\0\0"
  "\0\37\0\0\0;\0\0\0I\0\0\0J\0\0\0K\226\0\0\0L\6\0\0\0K\0\0\0I\0\0\0D\0"
  "\0\0.\0\0\0\20\0\0\0\2\235\0\0\0\0\6\0\0\0\1\0\0\0\13\0\0\0(\0\0\0I\0"
  "\0\0\270\0\0\0\343\230\0\0\0\377\5\12\27\12\377\33\77\33\377\0\0\0""8"
  "\0\0\0\23\0\0\0\2\235\0\0\0\0\7\0\0\0\1\0\0\0\14\0\0\0+\0\0\0J\0\0\0"
  "\343nnn\262\276\276\276\222\221\377\377\377\177\202&w&\377\11S\241R\377"
  "P\241P\377N\241M\377@\210\77\377+`,\377\12\27\12\377\0\0\0;\0\0\0\25"
  "\0\0\0\2\235\0\0\0\0\6\0\0\0\1\0\0\0\14\0\0\0,\0\0\0K\0\0\0\377\276\276"
  "\276\222\221\377\377\377\177\202&w&\377\12V\242U\377T\242R\377Q\241P"
  "\377N\241M\377K\240K\377>\211=\377\0\0\0\377\0\0\0<\0\0\0\26\0\0\0\2"
  "\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\221\377\377\377"
  "\177\202&w&\377\13X\242W\377V\242U\377T\242R\377Q\241P\377N\241M\377"
  "L\241K\377I\240I\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5"
  "\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\220\377\377\377\177\202&w&"
  "\377\14[\242Z\377Y\242X\377V\241U\377T\241S\377P\241P\377N\241N\377K"
  "\241K\377I\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0"
  "\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\217\377\377\377\177\202&w&\377"
  "\15^\242\\\377[\242Z\377X\241W\377V\241U\377T\241S\377Q\241P\377N\240"
  "N\377K\240K\377I\241H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0"
  "\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\216\377\377\377\177\202"
  "&w&\377\16`\243^\377^\242\\\377[\242Z\377Y\242W\377V\241U\377S\241R\377"
  "Q\241P\377N\241M\377L\241K\377H\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0"
  "\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\215\377"
  "\377\377\177\202&w&\377\17c\243a\377a\242_\377^\243]\377[\242Z\377Y\242"
  "W\377V\241T\377S\241R\377Q\241O\377N\241M\377L\240K\377H\240I\377\0\0"
  "\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,"
  "\0\0\0L\0\0\0\377\214\377\377\377\177\202&w&\377\20e\243d\377c\242a\377"
  "a\243_\377^\243]\377\\\242Z\377Y\241X\377U\241U\377T\241S\377P\241P\377"
  "N\241N\377K\240K\377H\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235"
  "\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\213\377\377\377\177"
  "\202&w&\377\21h\243g\377f\243d\377d\243b\377`\243_\377^\242\\\377[\242"
  "Z\377Y\242X\377V\242U\377S\241R\377P\241P\377N\241M\377K\241K\377I\240"
  "H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\4\0\0\0\1\0\0\0\14"
  "\0\0\0,\0\0\0L\234\0\0\0\377\3\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5"
  "\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\211\377\377\377\177\202&w&"
  "\377\23n\244k\377k\243h\377h\243f\377f\243d\377c\243a\377a\243_\377^"
  "\243\\\377\\\242Z\377Y\242X\377V\242U\377S\241S\377Q\241P\377N\241M\377"
  "K\240K\377H\240I\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5"
  "\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\210\377\377\377\177\202&w&"
  "\377\24p\245n\377m\244k\377k\244h\377h\244f\377f\243c\377c\243a\377a"
  "\243_\377^\243]\377[\242Z\377X\241W\377V\242U\377S\241S\377P\241P\377"
  "N\241M\377L\241K\377I\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235"
  "\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\207\377\377\377\177"
  "\202&w&\377\25s\245p\377q\244m\377n\244k\377k\243h\377i\243f\377f\243"
  "d\377d\243b\377a\242_\377]\243\\\377[\242Z\377Y\242W\377V\242U\377S\241"
  "S\377Q\241P\377N\241N\377L\240K\377H\240H\377\0\0\0\377\0\0\0=\0\0\0"
  "\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\206"
  "\377\377\377\177\202&w&\377\26v\245s\377s\244p\377q\244n\377n\244k\377"
  "l\244h\377i\243f\377e\243c\377c\243a\377`\242_\377^\242\\\377[\242Z\377"
  "Y\241W\377V\242U\377S\241S\377Q\241P\377N\240N\377K\241K\377I\240H\377"
  "\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0"
  "\0,\0\0\0L\0\0\0\377\205\377\377\377\177\202&w&\377\27x\245u\377v\245"
  "s\377t\245p\377p\244n\377n\244k\377k\244i\377i\244f\377f\243d\377c\243"
  "a\377a\242_\377]\243]\377[\242Y\377X\242W\377V\242U\377S\241R\377P\241"
  "P\377N\241N\377K\241K\377I\240I\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2"
  "\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\204\377\377\377"
  "\177\202&w&\377\30{\246x\377x\245u\377v\245s\377s\244p\377p\244n\377"
  "n\243k\377k\243i\377i\243f\377f\243c\377c\243b\377`\242_\377^\243]\377"
  "[\242Z\377Y\242X\377V\242U\377S\242S\377P\241P\377N\241N\377K\240K\377"
  "I\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\6\0\0\0\1\0"
  "\0\0\14\0\0\0,\0\0\0K\0\0\0\377\276\276\276\222\202\377\377\377\177\202"
  "&w&\377\31~\246z\377{\245w\377y\245u\377v\244r\377s\245p\377q\245m\377"
  "n\244k\377k\244i\377i\243f\377f\244d\377d\243b\377`\243_\377]\242\\\377"
  "[\242Z\377X\242X\377U\241T\377S\242S\377Q\241O\377N\241M\377K\241K\377"
  ">\210>\377\0\0\0\377\0\0\0<\0\0\0\26\0\0\0\2\235\0\0\0\0\7\0\0\0\1\0"
  "\0\0\13\0\0\0+\0\0\0J\0\0\0\343nnn\262\276\276\276\222\202&w&\377\32"
  "\201\246|\377~\246z\377{\245w\377x\244u\377v\245r\377t\245p\377p\244"
  "n\377n\244k\377k\243i\377h\244f\377e\243c\377c\243a\377a\243_\377^\242"
  "]\377[\242Z\377X\242W\377V\242U\377S\241R\377Q\241O\377N\241N\377@\210"
  "@\377,`+\377\12\27\12\377\0\0\0:\0\0\0\24\0\0\0\2\235\0\0\0\0\6\0\0\0"
  "\1\0\0\0\12\0\0\0&\0\0\0E\0\0\0\266\0\0\0\342\230\0\0\0\377\5\12\27\12"
  "\377\33\77\33\377\0\0\0""7\0\0\0\21\0\0\0\2\235\0\0\0\0\7\0\0\0\1\0\0"
  "\0\10\0\0\0\33\0\0\0.\0\0\0""8\0\0\0;\0\0\0<\223\0\0\0=\11\0\0\0>\0\0"
  "\0@\0\0\0D\0\0\0F\0\0\0G\0\0\0B\0\0\0+\0\0\0\14\0\0\0\1\236\0\0\0\0\5"
  "\0\0\0\3\0\0\0\12\0\0\0\20\0\0\0\23\0\0\0\24\223\0\0\0\26\12\0\0\0\27"
  "\0\0\0\31\0\0\0\34\0\0\0!\0\0\0&\0\0\0'\0\0\0$\0\0\0\26\0\0\0\7\0\0\0"
  "\1\236\0\0\0\0\1\0\0\0\1\227\0\0\0\2\11\0\0\0\3\0\0\0\4\0\0\0\6\0\0\0"
  "\10\0\0\0\12\3173\27\367\307+\23\364\0\0\0\27\0\0\0\5\272\0\0\0\0\12"
  "\0\0\0\1\3173\27\367\332=\34\377\331<\33\377\271'\21\343\0\0\0\34\0\0"
  "\0\3\302&\21\377\0\0\0\16\0\0\0\3\266\0\0\0\0\12\3173\27\344\332=\34"
  "\377\331<\33\377\330:\33\377\3248\31\376\263\40\16\350\302(\22\353\314"
  "0\26\377\0\0\0I\0\0\0\21\265\0\0\0\0\13\3204\27\360\332=\34\377\330<"
  "\33\377\327;\32\377\3269\32\377\3248\32\377\3237\31\377\3226\30\377\313"
  "0\25\377\0\0\0e\0\0\0\25\264\0\0\0\0\14\3204\30\352\332=\34\377\331<"
  "\33\377\327;\33\377\3269\32\377\3258\32\377\3236\31\377\3226\30\377\321"
  "5\30\377\312/\25\377\0\0\0j\0\0\0\25\264\0\0\0\0\14\307,\23\377\331<"
  "\33\377\330;\33\377\3269\32\377\3258\32\377\3237\31\377\3226\31\377\321"
  "4\30\377\3173\27\377\311.\25\377\0\0\0j\0\0\0\25\264\0\0\0\0\14\0\0\0"
  "\21\273(\21\352\3248\31\377\3248\32\377\3237\31\377\3226\31\377\3204"
  "\30\377\3173\27\377\3162\27\377\310-\24\377\0\0\0j\0\0\0\25\264\0\0\0"
  "\0\14\0\0\0\3\0\0\0\35\264\40\16\352\3236\31\377\3226\30\377\3215\30"
  "\377\3173\30\377\3162\27\377\3151\26\377\307,\23\377\0\0\0j\0\0\0\25"
  "\265\0\0\0\0\13\0\0\0\3\302(\22\353\3226\31\377\3214\30\377\3173\27\377"
  "\3161\27\377\3151\26\377\3140\25\377\306+\23\377\0\0\0j\0\0\0\25\265"
  "\0\0\0\0\13\303'\22\367\3141\26\377\313/\26\377\312.\25\377\311.\25\377"
  "\310-\24\377\307,\23\377\306+\23\377\302&\21\377\0\0\0j\0\0\0\25\265"
  "\0\0\0\0\3\0\0\0\15\0\0\0G\0\0\0d\202\0\0\0i\204\0\0\0j\2\0\0\0Y\0\0"
  "\0\22\265\0\0\0\0\6\0\0\0\3\0\0\0\20\0\0\0\25\0\0\0\30\0\0\0\36\0\0\0"
  "!\202\0\0\0#\6\0\0\0\"\0\0\0\34\0\0\0\14\0\0\0\6\0\0\0\4\0\0\0\3\225"
  "\0\0\0\2\1\0\0\0\1\236\0\0\0\0\14\0\0\0\3\0\0\0\20\0\0\0'\0\0\0""7\0"
  "\0\0:\0\0\0;\0\0\0""9\0\0\0""3\0\0\0*\0\0\0!\0\0\0\32\0\0\0\27\221\0"
  "\0\0\26\5\0\0\0\24\0\0\0\22\0\0\0\20\0\0\0\12\0\0\0\3\236\0\0\0\0\14"
  "\0\0\0\5\0\0\0\32\0\0\0C\0\0\0\\\0\0\0_\0\0\0^\0\0\0]\0\0\0W\0\0\0N\0"
  "\0\0F\0\0\0@\0\0\0>\220\0\0\0=\7\0\0\0<\0\0\0;\0\0\0""8\0\0\0.\0\0\0"
  "\32\0\0\0\10\0\0\0\1\235\0\0\0\0\5\0\0\0\4\0\0\0\31\0\0\0D\0\0\0\272"
  "\0\0\0\344\230\0\0\0\377\6\0\0\0\342\0\0\0\266\0\0\0D\0\0\0&\0\0\0\12"
  "\0\0\0\1\235\0\0\0\0\6\0\0\0\3\0\0\0\27\0\0\0>\0\0\0\343nnn\262\276\276"
  "\276\222\226\377\377\377\177\7\276\276\276\222nnn\262\0\0\0\342\0\0\0"
  "I\0\0\0+\0\0\0\13\0\0\0\1\235\0\0\0\0\5\0\0\0\2\0\0\0\26\0\0\0<\0\0\0"
  "\377\276\276\276\222\230\377\377\377\177\6\276\276\276\222\0\0\0\377"
  "\0\0\0K\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0"
  "=\0\0\0\377\232\377\377\377\177\5\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0"
  "\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\227\377\377\377"
  "\177\10c\235c\306*y*\372&w&\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0"
  "\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\224\377\377\377"
  "\177\2c\235c\306*y*\372\202&w&\377\7G\226F\377O\237O\377\0\0\0\377\0"
  "\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0"
  "\0\0\377\221\377\377\377\177\2\310\334\310\2226\2016\354\202&w&\377\12"
  "G\226F\377O\237O\377N\241M\377K\240J\377H\240I\377\0\0\0\377\0\0\0L\0"
  "\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377"
  "\217\377\377\377\177\1>\206>\344\202&w&\377\15:\2079\377T\235S\377V\241"
  "U\377T\241R\377Q\241P\377N\241M\377L\241K\377I\240I\377\0\0\0\377\0\0"
  "\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0"
  "\0\377\214\377\377\377\177\2\246\307\246\240-{-\366\202&w&\377\17X\235"
  "V\377^\242\\\377[\242Z\377Y\241W\377V\241U\377S\241R\377Q\241P\377N\240"
  "M\377L\240K\377H\240H\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235"
  "\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\213\377\377\377\177\202"
  "&w&\377\22F\214F\377b\240a\377c\242a\377`\242_\377^\242\\\377[\242Z\377"
  "Y\241X\377V\241U\377S\241R\377P\241P\377N\241M\377K\240K\377I\240H\377"
  "\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\3\0\0\0\2\0\0\0"
  "\26\0\0\0=\234\0\0\0\377\4\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0"
  "\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\211\377\377\377\177\202&w&\377\24"
  "n\244k\377k\243h\377h\243f\377f\243d\377c\243a\377a\243_\377^\243\\\377"
  "\\\242Z\377Y\242X\377V\242U\377S\241S\377Q\241P\377N\241M\377K\240K\377"
  "H\240I\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0"
  "\0\2\0\0\0\26\0\0\0=\0\0\0\377\210\377\377\377\177\202&w&\377\25p\245"
  "n\377m\244k\377k\244h\377h\244f\377f\243c\377c\243a\377a\243_\377^\243"
  "]\377[\242Z\377X\241W\377V\242U\377S\241S\377P\241P\377N\241M\377L\241"
  "K\377I\240H\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0"
  "\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\207\377\377\377\177\202&w&\377\26"
  "s\245p\377q\244m\377n\244k\377k\243h\377i\243f\377f\243d\377d\243b\377"
  "a\242_\377]\243\\\377[\242Z\377Y\242W\377V\242U\377S\241S\377Q\241P\377"
  "N\241N\377L\240K\377H\240H\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0"
  "\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\206\377\377\377\177"
  "\202&w&\377\27v\245s\377s\244p\377q\244n\377n\244k\377l\244h\377i\243"
  "f\377e\243c\377c\243a\377`\242_\377^\242\\\377[\242Z\377Y\241W\377V\242"
  "U\377S\241S\377Q\241P\377N\240N\377K\241K\377I\240H\377\0\0\0\377\0\0"
  "\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0"
  "\0\377\205\377\377\377\177\202&w&\377\30x\245u\377v\245s\377t\245p\377"
  "p\244n\377n\244k\377k\244i\377i\244f\377f\243d\377c\243a\377a\242_\377"
  "]\243]\377[\242Y\377X\242W\377V\242U\377S\241R\377P\241P\377N\241N\377"
  "K\241K\377I\240I\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0"
  "\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\204\377\377\377\177\202&w&\377"
  "\31{\246x\377x\245u\377v\245s\377s\244p\377p\244n\377n\243k\377k\243"
  "i\377i\243f\377f\243c\377c\243b\377`\242_\377^\243]\377[\242Z\377Y\242"
  "X\377V\242U\377S\242S\377P\241P\377N\241N\377K\240K\377I\240H\377\0\0"
  "\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\5\0\0\0\2\0\0\0\26"
  "\0\0\0<\0\0\0\377\276\276\276\222\202\377\377\377\177\202&w&\377\32~"
  "\246z\377{\245w\377y\245u\377v\244r\377s\245p\377q\245m\377n\244k\377"
  "k\244i\377i\243f\377f\244d\377d\243b\377`\243_\377]\242\\\377[\242Z\377"
  "X\242X\377U\241T\377S\242S\377Q\241O\377N\241M\377K\241K\377>\210>\377"
  "\0\0\0\377\0\0\0K\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\6\0\0\0\2\0\0\0"
  "\24\0\0\0:\0\0\0\342nnn\262\276\276\276\222\202&w&\377\33\201\246|\377"
  "~\246z\377{\245w\377x\244u\377v\245r\377t\245p\377p\244n\377n\244k\377"
  "k\243i\377h\244f\377e\243c\377c\243a\377a\243_\377^\242]\377[\242Z\377"
  "X\242W\377V\242U\377S\241R\377Q\241O\377N\241N\377@\210@\377,`+\377\12"
  "\27\12\377\0\0\0J\0\0\0+\0\0\0\14\0\0\0\1\235\0\0\0\0\5\0\0\0\2\0\0\0"
  "\22\0\0\0""8\0\0\0\266\0\0\0\342\230\0\0\0\377\6\12\27\12\377\33\77\33"
  "\377\0\0\0H\0\0\0(\0\0\0\13\0\0\0\1\235\0\0\0\0\6\0\0\0\2\0\0\0\20\0"
  "\0\0.\0\0\0D\0\0\0I\0\0\0K\226\0\0\0L\7\0\0\0K\0\0\0J\0\0\0I\0\0\0;\0"
  "\0\0\37\0\0\0\10\0\0\0\1\235\0\0\0\0\5\0\0\0\2\0\0\0\12\0\0\0\32\0\0"
  "\0&\0\0\0*\230\0\0\0,\5\0\0\0*\0\0\0(\0\0\0\36\0\0\0\17\0\0\0\4\236\0"
  "\0\0\0\5\0\0\0\1\0\0\0\3\0\0\0\10\0\0\0\12\0\0\0\13\230\0\0\0\14\202"
  "\0\0\0\13\3\0\0\0\10\0\0\0\4\0\0\0\1\243\0\0\0\0\230\0\0\0\1\206\0\0"
  "\0\0"};



  return local_pixstream;
}

/*-------- end ../sfi/sfidl generated code --------*/


