
/*-------- begin ../sfi/sfidl generated code --------*/



#include <bse/bsecxxplugin.hh>


/* enum prototypes */


/* choice prototypes */


/* record prototypes */


/* sequence prototypes */


/* class prototypes */
namespace Bse {
class AmplifierBase;
class Amplifier;
#define BSE_TYPE_AMPLIFIER		BSE_CXX_DECLARED_CLASS_TYPE (Bse, Amplifier)
#define BSE_IS_AMPLIFIER(o) (::Bse::CxxBase::instance_is_a (o, BSE_TYPE_AMPLIFIER))


/* enum definitions */


/* sequence definitions */


/* record definitions */


/* enum declarations */


/* sequence type declarations */


/* record type declarations */


/* procedure prototypes */


/* class definitions */
BSE_CXX_DECLARE_CLASS (Amplifier);
class AmplifierBase : public ::Bse::Effect {
  template<bool> static inline const unsigned char* inlined_pixstream();
public:
  static inline const unsigned char* pixstream () { return inlined_pixstream<true>(); }
  static void               class_init (::Bse::CxxBaseClass *klass);
  static inline const char* options   () { return ""; }
  static inline const char* category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules",  ("/Routing/Amplifier")); }
  static inline const char* i18n_category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules", _("/Routing/Amplifier")); }
  static inline const char* blurb     () { return _("BseAmplifier provides input signal controlled amplification or attenuation. It supports two control inputs and two audio inputs which are mixed together after balance and level adjustments. The gain setting controls preamplification of the mixed audio signal. The mixed control signal, weighted by a strength setting, determines additional amplification, allowing for external sources to modulate the overall volume (tremolo). The mixed control signal can influence the amplification linearly (to amplify other control signals) or exponentially (to amplify audio signals). Finally, the master volume controls amplification of the resulting output signal."); }
  static inline const char* authors   () { return "Tim Janik"; }
  static inline const char* license   () { return _("GNU Lesser General Public License"); }
  static inline const char* type_name () { return "BseAmplifier"; }
public:
  enum {
    ICHANNEL_AUDIO_IN1,
    ICHANNEL_AUDIO_IN2,
    ICHANNEL_CTRL_IN1,
    ICHANNEL_CTRL_IN2,
    N_ICHANNELS
  };
public:
  enum {
    OCHANNEL_AUDIO_OUT,
    N_OCHANNELS
  };
protected:
  enum AmplifierPropertyID {
    PROP_ALEVEL1 = 1,
    PROP_ALEVEL2,
    PROP_ABALANCE,
    PROP_CLEVEL1,
    PROP_CLEVEL2,
    PROP_CBALANCE,
    PROP_CTRL_MUL,
    PROP_CTRL_EXP,
    PROP_OSTRENGTH,
    PROP_BASE_LEVEL,
    PROP_MASTER_VOLUME,
    PROP_AUDIO_BALANCE,
    PROP_CTRL_BALANCE,
    PROP_CTRL_STRENGTH_F,
    PROP_MASTER_GAIN_F,
    PROP_AUDIO_GAIN_F,
    PROP_OLEVEL,
  };
public:
  /* "transport" structure to configure synthesis modules from properties */
  struct AmplifierProperties {
    typedef AmplifierPropertyID IDType;
    Sfi::Real alevel1;
    Sfi::Real alevel2;
    Sfi::Real abalance;
    Sfi::Real clevel1;
    Sfi::Real clevel2;
    Sfi::Real cbalance;
    bool ctrl_mul;
    bool ctrl_exp;
    Sfi::Real ostrength;
    Sfi::Real base_level;
    Sfi::Real master_volume;
    Sfi::Real audio_balance;
    Sfi::Real ctrl_balance;
    Sfi::Real ctrl_strength_f;
    Sfi::Real master_gain_f;
    Sfi::Real audio_gain_f;
    Sfi::Real olevel;
    explicit AmplifierProperties (AmplifierBase *p) :
      alevel1 (p->alevel1),
      alevel2 (p->alevel2),
      abalance (p->abalance),
      clevel1 (p->clevel1),
      clevel2 (p->clevel2),
      cbalance (p->cbalance),
      ctrl_mul (p->ctrl_mul),
      ctrl_exp (p->ctrl_exp),
      ostrength (p->ostrength),
      base_level (p->base_level),
      master_volume (p->master_volume),
      audio_balance (p->audio_balance),
      ctrl_balance (p->ctrl_balance),
      ctrl_strength_f (p->ctrl_strength_f),
      master_gain_f (p->master_gain_f),
      audio_gain_f (p->audio_gain_f),
      olevel (p->olevel)
    {
    }
  };
protected:
  typedef void AutoUpdateCategory;
protected:
  Sfi::Real alevel1;
  Sfi::Real alevel2;
  Sfi::Real abalance;
  Sfi::Real clevel1;
  Sfi::Real clevel2;
  Sfi::Real cbalance;
  bool ctrl_mul;
  bool ctrl_exp;
  Sfi::Real ostrength;
  Sfi::Real base_level;
  Sfi::Real master_volume;
  Sfi::Real audio_balance;
  Sfi::Real ctrl_balance;
  Sfi::Real ctrl_strength_f;
  Sfi::Real master_gain_f;
  Sfi::Real audio_gain_f;
  Sfi::Real olevel;
public:
  void get_property (AmplifierPropertyID prop_id, ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_ALEVEL1:
      sfi_value_set_real (&value, alevel1);
    break;
    case PROP_ALEVEL2:
      sfi_value_set_real (&value, alevel2);
    break;
    case PROP_ABALANCE:
      sfi_value_set_real (&value, abalance);
    break;
    case PROP_CLEVEL1:
      sfi_value_set_real (&value, clevel1);
    break;
    case PROP_CLEVEL2:
      sfi_value_set_real (&value, clevel2);
    break;
    case PROP_CBALANCE:
      sfi_value_set_real (&value, cbalance);
    break;
    case PROP_CTRL_MUL:
      sfi_value_set_bool (&value, ctrl_mul);
    break;
    case PROP_CTRL_EXP:
      sfi_value_set_bool (&value, ctrl_exp);
    break;
    case PROP_OSTRENGTH:
      sfi_value_set_real (&value, ostrength);
    break;
    case PROP_BASE_LEVEL:
      sfi_value_set_real (&value, base_level);
    break;
    case PROP_MASTER_VOLUME:
      sfi_value_set_real (&value, master_volume);
    break;
    case PROP_AUDIO_BALANCE:
      sfi_value_set_real (&value, audio_balance);
    break;
    case PROP_CTRL_BALANCE:
      sfi_value_set_real (&value, ctrl_balance);
    break;
    case PROP_CTRL_STRENGTH_F:
      sfi_value_set_real (&value, ctrl_strength_f);
    break;
    case PROP_MASTER_GAIN_F:
      sfi_value_set_real (&value, master_gain_f);
    break;
    case PROP_AUDIO_GAIN_F:
      sfi_value_set_real (&value, audio_gain_f);
    break;
    case PROP_OLEVEL:
      sfi_value_set_real (&value, olevel);
    break;
    };
  }
  void set_property (AmplifierPropertyID prop_id, const ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_ALEVEL1:
      alevel1 = sfi_value_get_real (&value);
    break;
    case PROP_ALEVEL2:
      alevel2 = sfi_value_get_real (&value);
    break;
    case PROP_ABALANCE:
      abalance = sfi_value_get_real (&value);
    break;
    case PROP_CLEVEL1:
      clevel1 = sfi_value_get_real (&value);
    break;
    case PROP_CLEVEL2:
      clevel2 = sfi_value_get_real (&value);
    break;
    case PROP_CBALANCE:
      cbalance = sfi_value_get_real (&value);
    break;
    case PROP_CTRL_MUL:
      ctrl_mul = sfi_value_get_bool (&value);
    break;
    case PROP_CTRL_EXP:
      ctrl_exp = sfi_value_get_bool (&value);
    break;
    case PROP_OSTRENGTH:
      ostrength = sfi_value_get_real (&value);
    break;
    case PROP_BASE_LEVEL:
      base_level = sfi_value_get_real (&value);
    break;
    case PROP_MASTER_VOLUME:
      master_volume = sfi_value_get_real (&value);
    break;
    case PROP_AUDIO_BALANCE:
      audio_balance = sfi_value_get_real (&value);
    break;
    case PROP_CTRL_BALANCE:
      ctrl_balance = sfi_value_get_real (&value);
    break;
    case PROP_CTRL_STRENGTH_F:
      ctrl_strength_f = sfi_value_get_real (&value);
    break;
    case PROP_MASTER_GAIN_F:
      master_gain_f = sfi_value_get_real (&value);
    break;
    case PROP_AUDIO_GAIN_F:
      audio_gain_f = sfi_value_get_real (&value);
    break;
    case PROP_OLEVEL:
      olevel = sfi_value_get_real (&value);
    break;
    };
    property_changed (AmplifierPropertyID (prop_id));
    update_modules();
    switch (prop_id) {
    default: ;
    };
  }
  virtual bool editable_property (AmplifierPropertyID prop_id, GParamSpec *pspec)
  {
    return true;
  }
  virtual void get_candidates (AmplifierPropertyID prop_id, ::Bse::PropertyCandidatesHandle &pch, GParamSpec *pspec)
  {
  }
  void property_updated (AmplifierPropertyID prop_id, guint64 tick_stamp, double prop_value, GParamSpec *pspec)
  {
    bool seen_change = false;
    switch (prop_id) {
    default: ;
    };
    if (seen_change &&
        property_changed (AmplifierPropertyID (prop_id)))
      update_modules();
  }
private:
  static struct StaticData {
    int dummy;
  } static_data;
protected:
  virtual bool property_changed (AmplifierPropertyID) { return false; }
  virtual ~AmplifierBase ()
  {
  }
public:
};


/* choice implementations */


/* record implementations */


/* sequence implementations */


/* class implementations */
void
AmplifierBase::class_init (::Bse::CxxBaseClass *klass)
{
  klass->set_accessors (::Bse::cxx_get_property_trampoline<AmplifierBase, AmplifierPropertyID>,
                        ::Bse::cxx_set_property_trampoline<AmplifierBase, AmplifierPropertyID>,
                        ::Bse::cxx_editable_property_trampoline<AmplifierBase, AmplifierPropertyID>,
                        ::Bse::cxx_get_candidates_trampoline<AmplifierBase, AmplifierPropertyID>,
                        NULL);
  klass->add_param (PROP_ALEVEL1, sfidl_pspec_Perc (_("Audio Input"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",887,"alevel1",_ ( "Input 1 [%]" ) , _ ( "Attenuate the level of audio input 1" ) , 100LL , ":r:w:S:G:"));
  klass->add_param (PROP_ALEVEL2, sfidl_pspec_Perc (_("Audio Input"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",888,"alevel2",_ ( "Input 2 [%]" ) , _ ( "Attenuate the level of audio input 2" ) , 100LL , ":r:w:S:G:"));
  klass->add_param (PROP_ABALANCE, sfidl_pspec_Balance (_("Audio Input"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",889,"abalance",_ ( "Balance" ) , _ ( "Balance audio input levels" ) , 0LL , ":r:w:G:"));
  klass->add_param (PROP_CLEVEL1, sfidl_pspec_Perc (_("Control Input"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",892,"clevel1",_ ( "Input 1 [%]" ) , _ ( "Attenuate the level of control input 1" ) , 100LL , ":r:w:S:G:"));
  klass->add_param (PROP_CLEVEL2, sfidl_pspec_Perc (_("Control Input"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",893,"clevel2",_ ( "Input 2 [%]" ) , _ ( "Attenuate the level of control input 2" ) , 100LL , ":r:w:S:G:"));
  klass->add_param (PROP_CBALANCE, sfidl_pspec_Balance (_("Control Input"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",894,"cbalance",_ ( "Balance" ) , _ ( "Balance control input levels" ) , 0LL , ":r:w:G:"));
  klass->add_param (PROP_CTRL_MUL, sfidl_pspec_Bool (_("Control Input"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",895,"ctrl_mul",_ ( "Multiply Controls" ) , _ ( "Switch the two control inputs to work like a chain of gain " "controls, rather than mixing them together, weighted by balance." ) , TRUE , ":r:w:S:G:"));
  klass->add_param (PROP_CTRL_EXP, sfidl_pspec_Bool (_("Control Input"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",899,"ctrl_exp",_ ( "Exponential Control" ) , _ ( "Toggle exponential and linear control response" ) , FALSE , ":r:w:S:G:"));
  klass->add_param (PROP_OSTRENGTH, sfidl_pspec_Perc (_("Output"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",902,"ostrength",_ ( "Control Strength" ) , _ ( "Adjust how much the control signals affect the output volume" ) , 100LL , ":r:w:S:G:"));
  klass->add_param (PROP_BASE_LEVEL, sfidl_pspec_Perc (_("Output"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",903,"base_level",_ ( "Base Volume" ) , _ ( "Base amplification (the control signal adds up to this)" ) , 0LL , ":r:w:S:G:"));
  klass->add_param (PROP_MASTER_VOLUME, sfidl_pspec_DBVolume (_("Output"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",904,"master_volume",_ ( "Master Volume" ) , _ ( "Output stage amplification in decibel" ) , 0LL , -96LL , + 24LL , ":r:w:S:G:"));
  klass->add_param (PROP_AUDIO_BALANCE, sfidl_pspec_Balance ("compat","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",907,"audio_balance",NULL , NULL , 0LL , "w"));
  klass->add_param (PROP_CTRL_BALANCE, sfidl_pspec_Balance ("compat","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",908,"ctrl_balance",NULL , NULL , 0LL , "w"));
  klass->add_param (PROP_CTRL_STRENGTH_F, sfidl_pspec_Real ("compat","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",909,"ctrl_strength_f",NULL , NULL , 1LL , 0LL , 1LL , 0.10000000000000001 , "w"));
  klass->add_param (PROP_MASTER_GAIN_F, sfidl_pspec_Real ("compat","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",910,"master_gain_f",NULL , NULL , 1LL , 0LL , 1LL , 0.10000000000000001 , "w"));
  klass->add_param (PROP_AUDIO_GAIN_F, sfidl_pspec_Real ("compat","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",911,"audio_gain_f",NULL , NULL , 0LL , 0LL , 1LL , 0.10000000000000001 , "w"));
  klass->add_param (PROP_OLEVEL, sfidl_pspec_Perc ("compat","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bseamplifier.idl",912,"olevel",NULL , NULL , 100LL , "w"));
  klass->add_ichannel ("audio_in1", _("Audio In1"), _("First audio input"), ICHANNEL_AUDIO_IN1);
  klass->add_ichannel ("audio_in2", _("Audio In2"), _("Second audio input"), ICHANNEL_AUDIO_IN2);
  klass->add_ichannel ("ctrl_in1", _("Ctrl In1"), _("First control input"), ICHANNEL_CTRL_IN1);
  klass->add_ichannel ("ctrl_in2", _("Ctrl In2"), _("Second control input"), ICHANNEL_CTRL_IN2);
  klass->add_ochannel ("audio_out", _("Audio Out"), _("Amplified audio output"), OCHANNEL_AUDIO_OUT);
}


/* procedure implementations */


/* bseamplifier.idl type registrations */
#define BSE_CXX_REGISTER_ALL_TYPES_FROM_BSEAMPLIFIER_IDL() \
  BSE_CXX_REGISTER_EFFECT (Amplifier); \
  /* bseamplifier.idl type registrations done */
} // Bse
template<bool> const unsigned char*
::Bse::AmplifierBase::inlined_pixstream()
{
  /* GdkPixbuf RGBA C-Source image dump 1-byte-run-length-encoded */

#ifdef __SUNPRO_C
#pragma align 4 (local_pixstream)
#endif
#ifdef __GNUC__
static const guint8 local_pixstream[] __attribute__ ((__aligned__ (4))) = 
#else
static const guint8 local_pixstream[] = 
#endif
{ ""
  /* Pixbuf magic (0x47646b50) */
  "GdkP"
  /* length: header (24) + pixel_data (4687) */
  "\0\0\22g"
  /* pixdata_type (0x2010002) */
  "\2\1\0\2"
  /* rowstride (256) */
  "\0\0\1\0"
  /* width (64) */
  "\0\0\0@"
  /* height (64) */
  "\0\0\0@"
  /* pixel_data: */
  "\377\0\0\0\0\377\0\0\0\0\262\0\0\0\0\214Z\0\0\377\264\0\0\0\0\214]\0"
  "\0\377\264\0\0\0\0\214`\0\0\377\264\0\0\0\0\214c\0\0\377\264\0\0\0\0"
  "\214f\0\0\377\264\0\0\0\0\214i\0\0\377\204\0\0\0\0\1^k\353\311\257\0"
  "\0\0\0\214m\0\0\377\204\0\0\0\0\2Gd\367\377bp\353\311\256\0\0\0\0\214"
  "p\0\0\377\204\0\0\0\0\3Gd\367\377Qn\367\377ht\353\311\222\0\0\0\0\4^"
  "^^~]]]\177TTT\200MMM\200\202JJJ\200\3MMM\200SSS\177TTT~\222\0\0\0\0\214"
  "s\0\0\377\204\0\0\0\0\4Gd\367\377Qn\367\377\\w\367\377mx\353\311\216"
  "\0\0\0\0\17WWW\177\251\251\250\357\250\250\250\377\233\233\233\377\226"
  "\226\226\377\221\221\221\377\216\216\216\377\212\212\212\377\207\207"
  "\207\377\204\204\204\377\202\202\202\377\201\201\201\377\211\211\211"
  "\377\214\213\213\357LLL\177\217\0\0\0\0\214v\0\0\377\204\0\0\0\0\5Gd"
  "\366\377Qn\367\377\\w\367\377g\200\370\377r}\353\311\213\0\0\0\0\16}"
  "||\257\247\247\247\377\240\240\240\377\231\231\231\377\223\223\223\377"
  "\215\215\215\377\210\210\210\377\204\204\204\377\200\200\200\377|||\377"
  "yyy\377vvv\377ttt\377sss\377\202rrr\377\3sss\377}}}\377ccc\257\215\0"
  "\0\0\0\214y\0\0\377\204\0\0\0\0\6jo\345uPm\366\377\\w\367\377g\200\370"
  "\377r\211\370\377w\201\353\311\210\0\0\0\0\20UUU\177\251\251\251\377"
  "\242\242\242\377\232\232\232\377\223\223\223\377\215\215\215\377\206"
  "\206\206\377\200\200\200\377{{{\377vvv\377rrr\377nnn\377kkk\377hhh\377"
  "fff\377eee\377\203ddd\377\4eee\377ggg\377sss\377@@@\177\213\0\0\0\0\214"
  "|\0\0\377\205\0\0\0\0\6nr\345uZu\366\377g\200\370\377r\211\370\377}\222"
  "\371\377|\205\353\311\206\0\0\0\0\21\200\200\200\277\247\247\247\377"
  "\236\236\236\377\226\226\226\377\216\216\216\377\207\207\207\377\200"
  "\200\200\377yyy\377sss\377nnn\377iii\377ddd\377```\377]]]\377ZZZ\377"
  "XXX\377WWW\377\203VVV\377\5WWW\377YYY\377[[[\377___\377VVV\277\212\0"
  "\0\0\0\214\177\0\0\377\206\0\0\0\0\6rv\345uc}\367\377r\211\370\377}\222"
  "\371\377\207\233\371\377\202\211\354\311\203\0\0\0\0\22***\77\253\253"
  "\253\376\245\245\245\377\234\234\234\377\223\223\223\377\212\212\212"
  "\377\202\202\202\377{{{\377sss\377mmm\377fff\377aaa\377[[[\377WWW\377"
  "SSS\377OOO\377LLL\377JJJ\377\204HHH\377\7III\377KKK\377NNN\377QQQ\377"
  "UUU\377fff\376\36\36\36\77\210\0\0\0\0\214\202\0\0\377\207\0\0\0\0\33"
  "vy\345um\205\367\377}\222\371\377\207\233\371\377\222\244\372\377\207"
  "\216\354\311\0\0\0\0***\77\254\254\254\377\244\244\244\377\232\232\232"
  "\377\221\221\221\377\210\210\210\377\177\177\177\377vvv\377ooo\377gg"
  "g\377```\377ZZZ\377TTT\377NNN\377III\377EEE\377AAA\377>>>\377<<<\377"
  ":::\377\202999\377\11:::\377;;;\377===\377@@@\377CCC\377GGG\377KKK\377"
  "[[[\377\34\34\34\77\207\0\0\0\0\214\205\0\0\377\210\0\0\0\0\32z}\345"
  "uw\215\370\377\207\233\371\377\222\244\372\377\235\255\372\377\214\223"
  "\354\311\253\253\253\376\244\244\244\377\231\231\231\377\220\220\220"
  "\377\206\206\206\377|||\377sss\377kkk\377ccc\377[[[\377TTT\377MMM\377"
  "GGG\377AAA\377<<<\377777\377333\377000\377...\377,,,\377\203+++\377\10"
  "---\377///\377222\377555\377999\377>>>\377DDD\377WWW\376\207\0\0\0\0"
  "\214\210\0\0\377\211\0\0\0\0\31~\200\345u\200\224\370\377\222\244\372"
  "\377\235\255\372\377\211\214\236\377\245\245\245\377\232\232\232\377"
  "\220\220\220\377\205\205\205\377{{{\377rrr\377hhh\377___\377WWW\377O"
  "OO\377GGG\377@@@\377:::\377444\377...\377***\377&&&\377\"\"\"\377\37"
  "\37\37\377\36\36\36\377\203\35\35\35\377\11\36\36\36\377!!!\377$$$\377"
  "(((\377,,,\377111\377777\377===\377===\277\206\0\0\0\0\214\213\0\0\377"
  "\212\0\0\0\0\30\202\204\345u\211\234\371\377z\202\250\377\247\247\247"
  "\377\234\234\234\377\221\221\221\377\206\206\206\377{{{\377qqq\377gg"
  "g\377^^^\377TTT\377KKK\377CCC\377;;;\377444\377---\377'''\377!!!\377"
  "\34\34\34\377\30\30\30\377\24\24\24\377\21\21\21\377\20\20\20\377\203"
  "\17\17\17\377\12\20\20\20\377\23\23\23\377\26\26\26\377\32\32\32\377"
  "\36\36\36\377$$$\377***\377000\377888\377,,,\177\205\0\0\0\0\214\216"
  "\0\0\377\213\0\0\0\0\27\206\206\345u\255\255\255\377\236\236\236\377"
  "\223\223\223\377\210\210\210\377|||\377rrr\377ggg\377]]]\377SSS\377I"
  "II\377@@@\377777\377///\377(((\377\40\40\40\377\32\32\32\377\24\24\24"
  "\377\17\17\17\377\12\12\12\377\6\6\6\377\4\4\4\377\3\3\3\377\203\2\2"
  "\2\377\12\3\3\3\377\5\5\5\377\10\10\10\377\14\14\14\377\21\21\21\377"
  "\27\27\27\377\35\35\35\377$$$\377+++\377;;;\377\205\0\0\0\0\214\221\0"
  "\0\377\213\0\0\0\0\24\205\205\205\257\242\242\242\377\226\226\226\377"
  "\212\212\212\377\177\177\177\377sss\377hhh\377^^^\377SSS\377III\377\77"
  "\77\77\377555\377,,,\377$$$\377\33\33\33\377\24\24\24\377\15\15\15\377"
  "\7\7\7\377\3\3\3\377\1\1\1\377\211\0\0\0\377\10\1\1\1\377\4\4\4\377\12"
  "\12\12\377\20\20\20\377\30\30\30\377\37\37\37\377(((\377888\257\204\0"
  "\0\0\0\214\224\0\0\377\213\0\0\0\0\21\256\256\256\377\232\232\232\377"
  "\216\216\216\377\202\202\202\377vvv\377kkk\377___\377TTT\377III\377\77"
  "\77\77\377555\377+++\377!!!\377\30\30\30\377\20\20\20\377\10\10\10\377"
  "\2\2\2\377\216\0\0\0\377\6\1\1\1\377\5\5\5\377\14\14\14\377\24\24\24"
  "\377\35\35\35\377...\377\204\0\0\0\0\214\227\0\0\377\212\0\0\0\0\21^"
  "^^\177\240\240\240\377\223\223\223\377\207\207\207\377{{{\377ooo\377"
  "ccc\377WWW\377KKK\377@@@\377555\377+++\377\40\40\40\377\27\27\27\377"
  "\15\15\15\377\5\5\5\377\1\1\1\377\221\0\0\0\377\5\2\2\2\377\11\11\11"
  "\377\22\22\22\377\33\33\33\377\34\34\34\177\203\0\0\0\0\214\232\0\0\377"
  "\212\0\0\0\0\17\252\252\252\357\231\231\231\377\215\215\215\377\200\200"
  "\200\377sss\377ggg\377[[[\377OOO\377CCC\377777\377,,,\377!!!\377\27\27"
  "\27\377\14\14\14\377\3\3\3\377\224\0\0\0\377\4\1\1\1\377\7\7\7\377\21"
  "\21\21\377322\357\203\0\0\0\0\214\236\0\0\377\212\0\0\0\0\16\245\245"
  "\245\377\223\223\223\377\206\206\206\377yyy\377mmm\377```\377TTT\377"
  "GGG\377;;;\377///\377$$$\377\30\30\30\377\15\15\15\377\3\3\3\377\226"
  "\0\0\0\377\3\1\1\1\377\10\10\10\377\31\31\31\377\203\0\0\0\0\214\241"
  "\0\0\377\211\0\0\0\0\16YYY~\233\233\233\377\215\215\215\377\200\200\200"
  "\377sss\377fff\377ZZZ\377MMM\377@@@\377444\377(((\377\33\33\33\377\20"
  "\20\20\377\5\5\5\377\205\0\0\0\377\5<\323U\3776\277M\3770\250D\377)\220"
  ":\377\"w0\377\216\0\0\0\377\3\1\1\1\377\12\12\12\377\34\34\34~\202\0"
  "\0\0\0\214\244\0\0\377\211\0\0\0\0\16XXX\177\226\226\226\377\210\210"
  "\210\377{{{\377nnn\377aaa\377TTT\377GGG\377:::\377---\377\40\40\40\377"
  "\24\24\24\377\10\10\10\377\1\1\1\377\204\0\0\0\377\7G\367c\377\77\336"
  "Y\3778\305O\3771\254E\377*\223;\377#z1\377\33a'\377\216\0\0\0\377\2\3"
  "\3\3\377\16\16\16\177\202\0\0\0\0\214\247\0\0\377\211\0\0\0\0\15QQQ\200"
  "\221\221\221\377\204\204\204\377vvv\377iii\377[[[\377NNN\377AAA\3774"
  "44\377'''\377\32\32\32\377\15\15\15\377\2\2\2\377\204\0\0\0\377\11<\323"
  "U\377\77\336Y\377<\323U\3776\277M\3770\250D\377)\220:\377\"w0\377\33"
  "_&\377\24F\34\377\216\0\0\0\377\23""8D~\377s\211\370\377z\220\371\377"
  "\201\226\371\377\211\234\371\377\220\242\372\377\227\250\372\377\237"
  "\256\372\377\246\265\373\377\256\273\373\377\265\301\373\377\274\307"
  "\374\377\304\315\374\377\313\323\374\377\322\332\375\377\332\340\375"
  "\377\341\346\375\377\350\354\376\377\360\362\376\377\205\0\0\0\0\14L"
  "LL\200\216\216\216\377\200\200\200\377rrr\377ddd\377WWW\377III\377<<"
  "<\377...\377!!!\377\24\24\24\377\7\7\7\377\205\0\0\0\377\11""6\277M\377"
  "8\305O\3776\277M\3772\260G\377-\235\77\377&\2076\377\40p-\377\31Y$\377"
  "\22A\32\377\216\0\0\0\377\23""6B|\377s\211\370\377z\220\371\377\201\226"
  "\371\377\211\234\371\377\220\242\372\377\227\250\372\377\237\256\372"
  "\377\246\265\373\377\256\273\373\377\265\301\373\377\274\307\374\377"
  "\304\315\374\377\313\323\374\377\322\332\375\377\332\340\375\377\341"
  "\346\375\377\350\354\376\377\360\362\376\377\205\0\0\0\0\14JJJ\200\212"
  "\212\212\377|||\377nnn\377```\377SSS\377EEE\377777\377***\377\34\34\34"
  "\377\17\17\17\377\3\3\3\377\204\0\0\0\377\12F\206Q\3770\250D\3771\254"
  "E\3770\250D\377-\235\77\377(\2159\377#z1\377\35e)\377\26O\40\377\20""8"
  "\27\377\216\0\0\0\377\23""5A{\377s\211\370\377z\220\371\377\201\226\371"
  "\377\211\234\371\377\220\242\372\377\227\250\372\377\237\256\372\377"
  "\246\265\373\377\256\273\373\377\265\301\373\377\274\307\374\377\304"
  "\315\374\377\313\323\374\377\322\332\375\377\332\340\375\377\341\346"
  "\375\377\350\354\376\377\360\362\376\377\205\0\0\0\0\14III\200\207\207"
  "\207\377yyy\377kkk\377]]]\377OOO\377AAA\377333\377&&&\377\30\30\30\377"
  "\12\12\12\377\1\1\1\377\202\0\0\0\377\14\23&\27\377_\271n\377\203\370"
  "\226\377)\220:\377*\223;\377)\220:\377&\2076\377#z1\377\36i*\377\31W"
  "#\377\23C\33\377\15-\22\377\216\0\0\0\377\1\1\1\1\200\202\0\0\0\0\214"
  "\263\0\0\377\211\0\0\0\0\13JJJ\200\204\204\204\377vvv\377hhh\377ZZZ\377"
  "LLL\377>>>\377000\377\"\"\"\377\24\24\24\377\6\6\6\377\202\0\0\0\377"
  "\15-Z4\377w\354\212\377\200\370\223\377\201\370\225\377\"w0\377#z1\377"
  "\"w0\377\40p-\377\35e)\377\31W#\377\24F\34\377\16""4\25\377\11\40\15"
  "\377\216\0\0\0\377\1\3\3\3\200\202\0\0\0\0\214\266\0\0\377\211\0\0\0"
  "\0\31MMM\177\202\202\202\377ttt\377fff\377XXX\377JJJ\377<<<\377...\377"
  "\37\37\37\377\21\21\21\377\4\4\4\377\0\0\0\377E\215P\377{\370\217\377"
  "}\370\221\377~\370\222\377\200\370\223\3779oB\377\33a'\377\33_&\377\31"
  "Y$\377\26O\40\377\23C\33\377\16""4\25\377\12#\16\377\217\0\0\0\377\1"
  "\4\4\4\177\202\0\0\0\0\214\271\0\0\377\211\0\0\0\0\21OOO~\201\201\201"
  "\377sss\377eee\377WWW\377HHH\377:::\377,,,\377\36\36\36\377\20\20\20"
  "\377\27""0\33\377\\\300l\377x\370\215\377z\370\216\377{\370\220\377h"
  "\317x\377\36<#\377\202\0\0\0\377\5\24F\34\377\22A\32\377\20""8\27\377"
  "\15-\22\377\11\40\15\377\220\0\0\0\377\1\15\15\15~\202\0\0\0\0\214\274"
  "\0\0\377\212\0\0\0\0\17\204\204\204\377rrr\377ddd\377VVV\377HHH\3779"
  "99\377+++\377\35\35\35\3775j>\377q\364\206\377u\370\212\377w\370\214"
  "\377x\370\215\377L\234Y\377\4\10\5\377\227\0\0\0\377\1\2\2\2\377\203"
  "\0\0\0\0\214\277\0\0\377\212\0\0\0\0\15\207\207\207\357rrr\377ddd\377"
  "VVV\377HHH\377999\377+,+\377M\237[\377p\370\206\377r\370\210\377s\370"
  "\211\377u\370\212\3772i;\377\231\0\0\0\377\1\21\21\21\357\203\0\0\0\0"
  "\214\302\0\0\377\212\0\0\0\0\14EEE\177sss\377ddd\377VVV\377HHH\377Db"
  "I\377^\320q\377m\370\204\377o\370\205\377p\370\206\377\\\307m\377\31"
  "5\35\377\232\0\0\0\377\1\3\3\3\177\203\0\0\0\0\214\305\0\0\377\213\0"
  "\0\0\0\13www\377eee\377WWW\377U\222_\377h\367\200\377j\367\201\377l\370"
  "\202\377m\370\204\377\\\226W\377\362\12<\377\364\11<\377\231\0\0\0\377"
  "\1\1\1\1\377\204\0\0\0\0\214\310\0\0\377\213\0\0\0\0\10^^^\257flg\377"
  "_\274n\377e\367}\377g\367~\377i\367\200\377i\365\177\377XkE\377\203\364"
  "\11<\377\231\0\0\0\377\1\15\15\15\257\204\0\0\0\0\214\313\0\0\377\213"
  "\0\0\0\0\7`\367y>b\340w\377b\367z\377d\367|\377f\367}\377[\313n\377["
  "E:\377\203\364\11<\377\1=\2\17\377\230\0\0\0\377\1\1\1\1\377\205\0\0"
  "\0\0\214\317\0\0\377\212\0\0\0\0\7]\367vs]\367v\377_\367x\377a\367y\377"
  "c\367{\377U\252c\377e+7\377\203\364\11<\377\1>\3\20\377\231\0\0\0\377"
  "\1\5\5\5\177\205\0\0\0\0\214\322\0\0\377\210\0\0\0\0\10Z\367s\21Y\367"
  "r\250Z\367t\377\\\367u\377^\367w\377^\361v\374Y\220b\377s8E\377\203\364"
  "\11<\377\2\203\16'\377\4\4\4\377\230\0\0\0\377\1\1\1\1\277\206\0\0\0"
  "\0\214\325\0\0\377\207\0\0\0\0\10V\367pFV\367p\336W\367q\377Y\367s\377"
  "[\367t\377\\\367v\277`\367x(\201P[\376\203\364\11<\377\4W\35)\377\27"
  "\27\27\377\12\12\12\377\1\1\1\377\226\0\0\0\377\1\7\7\7\376\207\0\0\0"
  "\0\214\330\0\0\377\206\0\0\0\0\6R\367m{S\367m\377T\367o\377V\367p\377"
  "X\367r\377Z\367s\212\202\0\0\0\0\10!\27\31\77\316\37E\377\364\11<\377"
  "\224\36""8\377***\377\35\35\35\377\20\20\20\377\5\5\5\377\225\0\0\0\377"
  "\2\4\4\4\377\4\4\4\77\207\0\0\0\0\214\333\0\0\377\204\0\0\0\0\7O\367"
  "j\30N\367i\260P\367k\377Q\367l\377S\367n\377U\367o\355X\367rU\204\0\0"
  "\0\0\10\37\25\27\77uCN\376===\377000\377$$$\377\30\30\30\377\14\14\14"
  "\377\2\2\2\377\223\0\0\0\377\2\7\7\7\376\4\4\4\77\210\0\0\0\0\214\336"
  "\0\0\377\204\0\0\0\0\6K\367g\345M\367h\377N\367j\377P\367k\377R\367l"
  "\270V\367p\40\207\0\0\0\0\7""333\277777\377+++\377\37\37\37\377\24\24"
  "\24\377\11\11\11\377\1\1\1\377\221\0\0\0\377\1\1\1\1\277\212\0\0\0\0"
  "\214\341\0\0\377\204\0\0\0\0\4J\367f\377K\367g\377M\367h\377P\367k\203"
  "\212\0\0\0\0\7$$$\177444\377(((\377\35\35\35\377\22\22\22\377\7\7\7\377"
  "\1\1\1\377\216\0\0\0\377\2\1\1\1\377\5\5\5\177\213\0\0\0\0\214\344\0"
  "\0\377\204\0\0\0\0\3J\367f\377J\367f\345N\367iN\215\0\0\0\0\6""111\257"
  "&&&\377\33\33\33\377\21\21\21\377\10\10\10\377\1\1\1\377\214\0\0\0\377"
  "\1\14\14\14\257\215\0\0\0\0\214\347\0\0\377\204\0\0\0\0\2K\367gkM\367"
  "h\30\220\0\0\0\0\5\22\22\22\177+++\357\22\22\22\377\12\12\12\377\3\3"
  "\3\377\210\0\0\0\377\2\16\16\16\357\2\2\2\177\217\0\0\0\0\214\352\0\0"
  "\377\231\0\0\0\0\3\26\26\26~\6\6\6\177\2\2\2\200\204\0\0\0\200\2\0\0"
  "\0\177\12\12\12~\222\0\0\0\0\214\355\0\0\377\264\0\0\0\0\214\360\0\0"
  "\377\264\0\0\0\0\214\363\0\0\377\264\0\0\0\0\214\366\0\0\377\264\0\0"
  "\0\0\214\371\0\0\377\264\0\0\0\0\214\374\0\0\377\377\0\0\0\0\377\0\0"
  "\0\0\377\0\0\0\0\207\0\0\0\0"};



  return local_pixstream;
}

/*-------- end ../sfi/sfidl generated code --------*/


