
/*-------- begin ../sfi/sfidl generated code --------*/



#include <bse/bsecxxplugin.hh>


/* enum prototypes */


/* choice prototypes */


/* record prototypes */


/* sequence prototypes */


/* class prototypes */
namespace Bse {
namespace Standard {
class QuantizerBase;
class Quantizer;
#define BSE_STANDARD_TYPE_QUANTIZER		BSE_CXX_DECLARED_CLASS_TYPE (Bse::Standard, Quantizer)
#define BSE_STANDARD_IS_QUANTIZER(o) (::Bse::CxxBase::instance_is_a (o, BSE_STANDARD_TYPE_QUANTIZER))


/* enum definitions */


/* sequence definitions */


/* record definitions */


/* enum declarations */


/* sequence type declarations */


/* record type declarations */


/* procedure prototypes */


/* class definitions */
BSE_CXX_DECLARE_CLASS (Quantizer);
class QuantizerBase : public ::Bse::Effect {
  template<bool> static inline const unsigned char* inlined_pixstream();
public:
  static inline const unsigned char* pixstream () { return inlined_pixstream<true>(); }
  static void               class_init (::Bse::CxxBaseClass *klass);
  static inline const char* options   () { return ""; }
  static inline const char* category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules", "/Distortion/Quantizer"); }
  static inline const char* i18n_category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules", "/Distortion/Quantizer"); }
  static inline const char* blurb     () { return _("The Quantizer plugin quantizes the input signals according to a configurable step setting. This simulates low quality digital signal transfer paths or ancient computer hardware."); }
  static inline const char* authors   () { return "Tim Janik"; }
  static inline const char* license   () { return ""; }
  static inline const char* type_name () { return "BseStandardQuantizer"; }
public:
  enum {
    ICHANNEL_AUDIO_IN1,
    ICHANNEL_AUDIO_IN2,
    N_ICHANNELS
  };
public:
  enum {
    OCHANNEL_AUDIO_OUT1,
    OCHANNEL_AUDIO_OUT2,
    N_OCHANNELS
  };
protected:
  enum QuantizerPropertyID {
    PROP_QSTEPS = 1,
    PROP_QSTEP_POWERS,
  };
public:
  /* "transport" structure to configure synthesis modules from properties */
  struct QuantizerProperties {
    typedef QuantizerPropertyID IDType;
    Sfi::Real qsteps;
    Sfi::Real qstep_powers;
    explicit QuantizerProperties (QuantizerBase *p) :
      qsteps (p->qsteps),
      qstep_powers (p->qstep_powers)
    {
    }
  };
protected:
  typedef void AutoUpdateCategory;
protected:
  Sfi::Real qsteps;
  Sfi::Real qstep_powers;
public:
  void get_property (QuantizerPropertyID prop_id, ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_QSTEPS:
      sfi_value_set_real (&value, qsteps);
    break;
    case PROP_QSTEP_POWERS:
      sfi_value_set_real (&value, qstep_powers);
    break;
    };
  }
  void set_property (QuantizerPropertyID prop_id, const ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_QSTEPS:
      qsteps = sfi_value_get_real (&value);
    break;
    case PROP_QSTEP_POWERS:
      qstep_powers = sfi_value_get_real (&value);
    break;
    };
    property_changed (QuantizerPropertyID (prop_id));
    update_modules();
    switch (prop_id) {
    default: ;
    };
  }
  virtual bool editable_property (QuantizerPropertyID prop_id, GParamSpec *pspec)
  {
    return true;
  }
  virtual void get_candidates (QuantizerPropertyID prop_id, ::Bse::PropertyCandidatesHandle &pch, GParamSpec *pspec)
  {
  }
  void property_updated (QuantizerPropertyID prop_id, guint64 tick_stamp, double prop_value, GParamSpec *pspec)
  {
    bool seen_change = false;
    switch (prop_id) {
    default: ;
    };
    if (seen_change &&
        property_changed (QuantizerPropertyID (prop_id)))
      update_modules();
  }
private:
  static struct StaticData {
    int dummy;
  } static_data;
protected:
  virtual bool property_changed (QuantizerPropertyID) { return false; }
  virtual ~QuantizerBase ()
  {
  }
public:
};


/* choice implementations */


/* record implementations */


/* sequence implementations */


/* class implementations */
void
QuantizerBase::class_init (::Bse::CxxBaseClass *klass)
{
  klass->set_accessors (::Bse::cxx_get_property_trampoline<QuantizerBase, QuantizerPropertyID>,
                        ::Bse::cxx_set_property_trampoline<QuantizerBase, QuantizerPropertyID>,
                        ::Bse::cxx_editable_property_trampoline<QuantizerBase, QuantizerPropertyID>,
                        ::Bse::cxx_get_candidates_trampoline<QuantizerBase, QuantizerPropertyID>,
                        NULL);
  klass->add_param (PROP_QSTEPS, sfidl_pspec_Real (_("Quantization"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bsequantizer.idl",2666,"qsteps",_ ( "Quantization Steps" ) , _ ( "The number of different steps the output signal is quantized to." ) , 256LL , 1LL , 4294967296LL , 256LL , ":r:w:S:G:" ":scale"));
  klass->add_param (PROP_QSTEP_POWERS, sfidl_pspec_Real (_("Quantization"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/bsequantizer.idl",2667,"qstep_powers",_ ( "Bit Depth" ) , _ ( "The number of bits the quantization steps correspond to." ) , 8LL , 0LL , 32LL , 0.0625 , ":r:w:G:" ":scale"));
  klass->add_ichannel ("audio_in1", "Audio In1", "Audio Input 1", ICHANNEL_AUDIO_IN1);
  klass->add_ichannel ("audio_in2", "Audio In2", "Audio Input 2", ICHANNEL_AUDIO_IN2);
  klass->add_ochannel ("audio_out1", "Audio Out1", "Audio Output 1", OCHANNEL_AUDIO_OUT1);
  klass->add_ochannel ("audio_out2", "Audio Out2", "Audio Output 2", OCHANNEL_AUDIO_OUT2);
}


/* procedure implementations */


/* bsequantizer.idl type registrations */
#define BSE_CXX_REGISTER_ALL_TYPES_FROM_BSEQUANTIZER_IDL() \
  BSE_CXX_REGISTER_EFFECT (Quantizer); \
  /* bsequantizer.idl type registrations done */
} // Standard
} // Bse
template<bool> const unsigned char*
::Bse::Standard::QuantizerBase::inlined_pixstream()
{
  /* GdkPixbuf RGBA C-Source image dump 1-byte-run-length-encoded */

#ifdef __SUNPRO_C
#pragma align 4 (local_pixstream)
#endif
#ifdef __GNUC__
static const guint8 local_pixstream[] __attribute__ ((__aligned__ (4))) = 
#else
static const guint8 local_pixstream[] = 
#endif
{ ""
  /* Pixbuf magic (0x47646b50) */
  "GdkP"
  /* length: header (24) + pixel_data (5177) */
  "\0\0\24Q"
  /* pixdata_type (0x2010002) */
  "\2\1\0\2"
  /* rowstride (256) */
  "\0\0\1\0"
  /* width (64) */
  "\0\0\0@"
  /* height (64) */
  "\0\0\0@"
  /* pixel_data: */
  "\206\0\0\0\0\230\0\0\0\1\243\0\0\0\0\3\0\0\0\1\0\0\0\4\0\0\0\10\202\0"
  "\0\0\13\230\0\0\0\14\5\0\0\0\13\0\0\0\12\0\0\0\10\0\0\0\3\0\0\0\1\236"
  "\0\0\0\0\5\0\0\0\4\0\0\0\17\0\0\0\36\0\0\0(\0\0\0*\230\0\0\0,\5\0\0\0"
  "*\0\0\0&\0\0\0\32\0\0\0\12\0\0\0\2\235\0\0\0\0\7\0\0\0\1\0\0\0\10\0\0"
  "\0\37\0\0\0;\0\0\0I\0\0\0J\0\0\0K\226\0\0\0L\6\0\0\0K\0\0\0I\0\0\0D\0"
  "\0\0.\0\0\0\20\0\0\0\2\235\0\0\0\0\6\0\0\0\1\0\0\0\13\0\0\0(\0\0\0I\0"
  "\0\0\270\0\0\0\343\230\0\0\0\377\5\12\27\12\377\33\77\33\377\0\0\0""8"
  "\0\0\0\23\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0+\0\0\0J\0\0\0"
  "\343\223\377\377\377\177\202&w&\377\11S\241R\377P\241P\377N\241M\377"
  "@\210\77\377+`,\377\12\27\12\377\0\0\0;\0\0\0\25\0\0\0\2\235\0\0\0\0"
  "\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0K\0\0\0\377\222\377\377\377\177\202&"
  "w&\377\12V\242U\377T\242R\377Q\241P\377N\241M\377K\240K\377>\211=\377"
  "\0\0\0\377\0\0\0<\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0"
  "\0,\0\0\0L\0\0\0\377\221\377\377\377\177\202&w&\377\13X\242W\377V\242"
  "U\377T\242R\377Q\241P\377N\241M\377L\241K\377I\240I\377\0\0\0\377\0\0"
  "\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0"
  "\0\377\220\377\377\377\177\202&w&\377\14[\242Z\377Y\242X\377V\241U\377"
  "T\241S\377P\241P\377N\241N\377K\241K\377I\240H\377\0\0\0\377\0\0\0=\0"
  "\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377"
  "\217\377\377\377\177\202&w&\377\15^\242\\\377[\242Z\377X\241W\377V\241"
  "U\377T\241S\377Q\241P\377N\240N\377K\240K\377I\241H\377\0\0\0\377\0\0"
  "\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0"
  "\0\377\216\377\377\377\177\202&w&\377\16`\243^\377^\242\\\377[\242Z\377"
  "Y\242W\377V\241U\377S\241R\377Q\241P\377N\241M\377L\241K\377H\240H\377"
  "\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0"
  "\0,\0\0\0L\0\0\0\377\215\377\377\377\177\202&w&\377\17c\243a\377a\242"
  "_\377^\243]\377[\242Z\377Y\242W\377V\241T\377S\241R\377Q\241O\377N\241"
  "M\377L\240K\377H\240I\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0"
  "\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\214\377\377\377\177\202"
  "&w&\377\20e\243d\377c\242a\377a\243_\377^\243]\377\\\242Z\377Y\241X\377"
  "U\241U\377T\241S\377P\241P\377N\241N\377K\240K\377H\240H\377\0\0\0\377"
  "\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0"
  "L\0\0\0\377\213\377\377\377\177\202&w&\377\21h\243g\377f\243d\377d\243"
  "b\377`\243_\377^\242\\\377[\242Z\377Y\242X\377V\242U\377S\241R\377P\241"
  "P\377N\241M\377K\241K\377I\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2"
  "\235\0\0\0\0\4\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\234\0\0\0\377\3\0\0\0="
  "\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0"
  "\377\211\377\377\377\177\202&w&\377\23n\244k\377k\243h\377h\243f\377"
  "f\243d\377c\243a\377a\243_\377^\243\\\377\\\242Z\377Y\242X\377V\242U"
  "\377S\241S\377Q\241P\377N\241M\377K\240K\377H\240I\377\0\0\0\377\0\0"
  "\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0"
  "\0\377\210\377\377\377\177\202&w&\377\24p\245n\377m\244k\377k\244h\377"
  "h\244f\377f\243c\377c\243a\377a\243_\377^\243]\377[\242Z\377X\241W\377"
  "V\242U\377S\241S\377P\241P\377N\241M\377L\241K\377I\240H\377\0\0\0\377"
  "\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0"
  "L\0\0\0\377\207\377\377\377\177\202&w&\377\25s\245p\377q\244m\377n\244"
  "k\377k\243h\377i\243f\377f\243d\377d\243b\377a\242_\377]\243\\\377[\242"
  "Z\377Y\242W\377V\242U\377S\241S\377Q\241P\377N\241N\377L\240K\377H\240"
  "H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14"
  "\0\0\0,\0\0\0L\0\0\0\377\206\377\377\377\177\202&w&\377\26v\245s\377"
  "s\244p\377q\244n\377n\244k\377l\244h\377i\243f\377e\243c\377c\243a\377"
  "`\242_\377^\242\\\377[\242Z\377Y\241W\377V\242U\377S\241S\377Q\241P\377"
  "N\240N\377K\241K\377I\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235"
  "\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\205\377\377\377\177"
  "\202&w&\377\27x\245u\377v\245s\377t\245p\377p\244n\377n\244k\377k\244"
  "i\377i\244f\377f\243d\377c\243a\377a\242_\377]\243]\377[\242Y\377X\242"
  "W\377V\242U\377S\241R\377P\241P\377N\241N\377K\241K\377I\240I\377\0\0"
  "\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,"
  "\0\0\0L\0\0\0\377\204\377\377\377\177\202&w&\377\30{\246x\377x\245u\377"
  "v\245s\377s\244p\377p\244n\377n\243k\377k\243i\377i\243f\377f\243c\377"
  "c\243b\377`\242_\377^\243]\377[\242Z\377Y\242X\377V\242U\377S\242S\377"
  "P\241P\377N\241N\377K\240K\377I\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0"
  "\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0K\0\0\0\377\203\377"
  "\377\377\177\202&w&\377\31~\246z\377{\245w\377y\245u\377v\244r\377s\245"
  "p\377q\245m\377n\244k\377k\244i\377i\243f\377f\244d\377d\243b\377`\243"
  "_\377]\242\\\377[\242Z\377X\242X\377U\241T\377S\242S\377Q\241O\377N\241"
  "M\377K\241K\377>\210>\377\0\0\0\377\0\0\0<\0\0\0\26\0\0\0\2\235\0\0\0"
  "\0\5\0\0\0\1\0\0\0\13\0\0\0+\0\0\0J\12\12\26\363\202\377\377\377\177"
  "\202&w&\377\32\201\246|\377~\246z\377{\245w\377x\244u\377v\245r\377t"
  "\245p\377p\244n\377n\244k\377k\243i\377h\244f\377e\243c\377c\243a\377"
  "a\243_\377^\242]\377[\242Z\377X\242W\377V\242U\377S\241R\377Q\241O\377"
  "N\241N\377@\210@\377,`+\377\12\27\12\377\0\0\0:\0\0\0\24\0\0\0\2\235"
  "\0\0\0\0\6\0\0\0\1\0\0\0\12\0\0\0&\0\0\0E\36\40B\341\12\13\26\363\230"
  "\0\0\0\377\5\12\27\12\377\33\77\33\377\0\0\0""7\0\0\0\21\0\0\0\2\235"
  "\0\0\0\0\7\0\0\0\1\0\0\0\10\0\0\0\33\0\0\0.\0\0\0""8\0\0\0;\0\0\0<\223"
  "\0\0\0=\11\0\0\0>\0\0\0@\0\0\0D\0\0\0F\0\0\0G\0\0\0B\0\0\0+\0\0\0\14"
  "\0\0\0\1\236\0\0\0\0\5\0\0\0\3\0\0\0\12\0\0\0\20\0\0\0\23\0\0\0\24\223"
  "\0\0\0\26\12\0\0\0\27\0\0\0\31\0\0\0\34\0\0\0!\0\0\0&\0\0\0'\0\0\0$\0"
  "\0\0\26\0\0\0\7\0\0\0\1\236\0\0\0\0\1\0\0\0\1\227\0\0\0\2\11\0\0\0\3"
  "\0\0\0\4\0\0\0\6\0\0\0\10\0\0\0\12\3173\27\367\307+\23\364\0\0\0\27\0"
  "\0\0\5\272\0\0\0\0\12\0\0\0\1\3173\27\367\332=\34\377\331<\33\377\271"
  "'\21\343\0\0\0\34\0\0\0\3\302&\21\377\0\0\0\16\0\0\0\3\266\0\0\0\0\12"
  "\3173\27\344\332=\34\377\331<\33\377\330:\33\377\3248\31\376\263\40\16"
  "\350\302(\22\353\3140\26\377\0\0\0I\0\0\0\21\265\0\0\0\0\13\3204\27\360"
  "\332=\34\377\330<\33\377\327;\32\377\3269\32\377\3248\32\377\3237\31"
  "\377\3226\30\377\3130\25\377\0\0\0e\0\0\0\25\264\0\0\0\0\14\3204\30\352"
  "\332=\34\377\331<\33\377\327;\33\377\3269\32\377\3258\32\377\3236\31"
  "\377\3226\30\377\3215\30\377\312/\25\377\0\0\0j\0\0\0\25\264\0\0\0\0"
  "\14\307,\23\377\331<\33\377\330;\33\377\3269\32\377\3258\32\377\3237"
  "\31\377\3226\31\377\3214\30\377\3173\27\377\311.\25\377\0\0\0j\0\0\0"
  "\25\264\0\0\0\0\14\0\0\0\21\273(\21\352\3248\31\377\3248\32\377\3237"
  "\31\377\3226\31\377\3204\30\377\3173\27\377\3162\27\377\310-\24\377\0"
  "\0\0j\0\0\0\25\264\0\0\0\0\14\0\0\0\3\0\0\0\35\264\40\16\352\3236\31"
  "\377\3226\30\377\3215\30\377\3173\30\377\3162\27\377\3151\26\377\307"
  ",\23\377\0\0\0j\0\0\0\25\265\0\0\0\0\13\0\0\0\3\302(\22\353\3226\31\377"
  "\3214\30\377\3173\27\377\3161\27\377\3151\26\377\3140\25\377\306+\23"
  "\377\0\0\0j\0\0\0\25\265\0\0\0\0\13\303'\22\367\3141\26\377\313/\26\377"
  "\312.\25\377\311.\25\377\310-\24\377\307,\23\377\306+\23\377\302&\21"
  "\377\0\0\0j\0\0\0\25\265\0\0\0\0\3\0\0\0\15\0\0\0G\0\0\0d\202\0\0\0i"
  "\204\0\0\0j\2\0\0\0Y\0\0\0\22\265\0\0\0\0\6\0\0\0\3\0\0\0\20\0\0\0\25"
  "\0\0\0\30\0\0\0\36\0\0\0!\202\0\0\0#\6\0\0\0\"\0\0\0\34\0\0\0\14\0\0"
  "\0\6\0\0\0\4\0\0\0\3\225\0\0\0\2\1\0\0\0\1\236\0\0\0\0\14\0\0\0\3\0\0"
  "\0\20\0\0\0'\0\0\0""7\0\0\0:\0\0\0;\0\0\0""9\0\0\0""3\0\0\0*\0\0\0!\0"
  "\0\0\32\0\0\0\27\221\0\0\0\26\5\0\0\0\24\0\0\0\22\0\0\0\20\0\0\0\12\0"
  "\0\0\3\236\0\0\0\0\14\0\0\0\5\0\0\0\32\0\0\0C\0\0\0\\\0\0\0_\0\0\0^\0"
  "\0\0]\0\0\0W\0\0\0N\0\0\0F\0\0\0@\0\0\0>\220\0\0\0=\7\0\0\0<\0\0\0;\0"
  "\0\0""8\0\0\0.\0\0\0\32\0\0\0\10\0\0\0\1\235\0\0\0\0\5\0\0\0\4\0\0\0"
  "\31\0\0\0D\0\0\0\272\0\0\0\344\230\0\0\0\377\6\0\0\0\342\0\0\0\266\0"
  "\0\0D\0\0\0&\0\0\0\12\0\0\0\1\235\0\0\0\0\4\0\0\0\3\0\0\0\27\0\0\0>\0"
  "\0\0\343\225\377\377\377\200\12&w&\3778bn\3775`l\3773^j\3772]i\377\0"
  "\0\0\342\0\0\0I\0\0\0+\0\0\0\13\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26"
  "\0\0\0<\0\0\0\377\217\377\377\377\200\207&w&\377\11""5`l\3774_k\3772"
  "]i\3771\\h\377\0\0\0\377\0\0\0K\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4"
  "\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\217\377\377\377\200\20&w&\377\77i"
  "u\377>ht\377;fr\377:dq\3778bn\3775`l\3774_k\3772]i\3771\\h\377.Yf\377"
  "\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0"
  "\26\0\0\0=\0\0\0\377\217\377\377\377\200\20&w&\377\77iu\377;fr\377:d"
  "q\3778bn\3775`l\3774_k\3773^j\3771\\h\377.Yf\377,Wd\377\0\0\0\377\0\0"
  "\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0"
  "\0\377\217\377\377\377\200\20&w&\377=gs\377:dq\3778bn\3777am\3774_k\377"
  "3^j\3771\\h\377.Yf\377,Wd\377+Vc\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14"
  "\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\217\377\377"
  "\377\200\20&w&\377:dq\3779co\3777am\3774_k\3773^j\3771\\h\3770[g\377"
  "-Xe\377+Vc\377*Ub\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0"
  "\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\217\377\377\377\200\20&w&"
  "\3779co\3778bn\3775`l\3773^j\3772]i\3770[g\377-Xe\377+Vc\377*Ub\377("
  "S`\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2"
  "\0\0\0\26\0\0\0=\0\0\0\377\217\377\377\377\200\7&w&\3778bn\3775`l\377"
  "4_k\3772]i\3771\\h\377-Xe\377\202+Vc\377\7)Ta\377'R_\377\0\0\0\377\0"
  "\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0"
  "\0\0\377\210\377\377\377\200\210&w&\377\17""5`l\3774_k\3773^j\3770[g"
  "\377.Yf\377,Wd\377+Vc\377)Ta\377'R_\377&Q^\377\0\0\0\377\0\0\0L\0\0\0"
  ",\0\0\0\14\0\0\0\1\233\0\0\0\0\5\0\0\0\1\0\0\0\0\0\0\0\2\0\0\0\26\0\0"
  "\0=\234\0\0\0\377\4\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0"
  "\0\2\0\0\0\26\0\0\0=\0\0\0\377\210\377\377\377\200\27&w&\377Ajv\377\77"
  "iu\377=gs\377:dq\3778bn\3775`l\3774_k\3773^j\3771\\h\377.Yf\377,Wd\377"
  "+Vc\377*Ub\377(S`\377&Q^\377$O\\\377#NZ\377\0\0\0\377\0\0\0L\0\0\0,\0"
  "\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\210\377"
  "\377\377\200\27&w&\377\77iu\377=gs\377:dq\3779co\3778bn\3774_k\3773^"
  "j\3771\\h\377.Yf\377,Wd\377+Vc\377*Ub\377(S`\377&Q^\377%P]\377#NZ\377"
  "#MY\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0"
  "\2\0\0\0\26\0\0\0=\0\0\0\377\210\377\377\377\200\27&w&\377=gs\377;fr"
  "\3779co\3778bn\3775`l\3773^j\3772]i\3770[g\377-Xe\377,Wd\377*Ub\377("
  "S`\377'R_\377&Q^\377#NZ\377#MY\377!JV\377\0\0\0\377\0\0\0L\0\0\0,\0\0"
  "\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\210\377"
  "\377\377\200\11&w&\377;fr\3779co\3778bn\3775`l\3774_k\3772]i\3770[g\377"
  "-Xe\377\202+Vc\377\14)Ta\377'R_\377&Q^\377$O\\\377#MY\377!JV\377!IU\377"
  "\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0"
  "\26\0\0\0=\0\0\0\377\210\377\377\377\200\27&w&\3779co\3778bn\3775`l\377"
  "4_k\3772]i\3771\\h\377-Xe\377,Wd\377+Vc\377)Ta\377'R_\377&Q^\377$O\\"
  "\377#NZ\377!JV\377!IU\377\40HS\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0"
  "\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\210\377\377\377"
  "\200\27&w&\3778bn\3775`l\3774_k\3773^j\3770[g\377.Yf\377,Wd\377+Vc\377"
  ")Ta\377'R_\377&Q^\377$O\\\377#NZ\377\"LX\377!IU\377\40HS\377\37FQ\377"
  "\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0"
  "\26\0\0\0<\0\0\0\377\211&w&\377\26""5`l\3774_k\3773^j\3771\\h\3770[g"
  "\377,Wd\377+Vc\377*Ub\377(S`\377&Q^\377%P]\377#NZ\377#MY\377!JV\377\40"
  "HS\377\37FQ\377\37DO\377\0\0\0\377\0\0\0K\0\0\0,\0\0\0\14\0\0\0\1\235"
  "\0\0\0\0#\0\0\0\2\0\0\0\24\0\0\0:\12\13\26\363Fo{\377Dny\377Clx\377A"
  "jv\377\77iu\377=gs\377:dq\3778bn\3777am\3774_k\3773^j\3771\\h\377.Yf"
  "\377,Wd\377+Vc\377*Ub\377(S`\377'R_\377%P]\377#NZ\377#MY\377!JV\377!"
  "IU\377\40GR\377\37DO\377\36CN\377\14\21\34\377\0\0\0J\0\0\0+\0\0\0\14"
  "\0\0\0\1\235\0\0\0\0\5\0\0\0\2\0\0\0\22\0\0\0""8\36\40B\341\12\12\26"
  "\363\230\0\0\0\377\6\14\21\34\377\"/L\377\0\0\0H\0\0\0(\0\0\0\13\0\0"
  "\0\1\235\0\0\0\0\6\0\0\0\2\0\0\0\20\0\0\0.\0\0\0D\0\0\0I\0\0\0K\226\0"
  "\0\0L\7\0\0\0K\0\0\0J\0\0\0I\0\0\0;\0\0\0\37\0\0\0\10\0\0\0\1\235\0\0"
  "\0\0\5\0\0\0\2\0\0\0\12\0\0\0\32\0\0\0&\0\0\0*\230\0\0\0,\5\0\0\0*\0"
  "\0\0(\0\0\0\36\0\0\0\17\0\0\0\4\236\0\0\0\0\5\0\0\0\1\0\0\0\3\0\0\0\10"
  "\0\0\0\12\0\0\0\13\230\0\0\0\14\202\0\0\0\13\3\0\0\0\10\0\0\0\4\0\0\0"
  "\1\243\0\0\0\0\230\0\0\0\1\206\0\0\0\0"};



  return local_pixstream;
}

/*-------- end ../sfi/sfidl generated code --------*/


