
/*-------- begin ../sfi/sfidl generated code --------*/



#include <bse/bsecxxplugin.hh>


/* enum prototypes */


/* choice prototypes */


/* record prototypes */


/* sequence prototypes */


/* class prototypes */
namespace Bse {
namespace Dav {
class BassFilterBase;
class BassFilter;
#define BSE_DAV_TYPE_BASS_FILTER		BSE_CXX_DECLARED_CLASS_TYPE (Bse::Dav, BassFilter)
#define BSE_DAV_IS_BASS_FILTER(o) (::Bse::CxxBase::instance_is_a (o, BSE_DAV_TYPE_BASS_FILTER))


/* enum definitions */


/* sequence definitions */


/* record definitions */


/* enum declarations */


/* sequence type declarations */


/* record type declarations */


/* procedure prototypes */


/* class definitions */
BSE_CXX_DECLARE_CLASS (BassFilter);
class BassFilterBase : public ::Bse::Effect {
  template<bool> static inline const unsigned char* inlined_pixstream();
public:
  static inline const unsigned char* pixstream () { return inlined_pixstream<true>(); }
  static void               class_init (::Bse::CxxBaseClass *klass);
  static inline const char* options   () { return ""; }
  static inline const char* category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules",  ("/Filters/Bass Filter")); }
  static inline const char* i18n_category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules", _("/Filters/Bass Filter")); }
  static inline const char* blurb     () { return _("DavBassFilter is a low-pass resonant TB-303 style filter based on the VCF303 portions of gsyn v0.2. The filter algorithm is partly based on the one described in \"Musical Applications of Microprocessors\" by Hal Chamberlin."); }
  static inline const char* authors   () { return "David A. Bartold, Tim Janik"; }
  static inline const char* license   () { return _("GNU Lesser General Public License"); }
  static inline const char* type_name () { return "BseDavBassFilter"; }
public:
  enum {
    ICHANNEL_AUDIO_IN,
    ICHANNEL_TRIGGER_IN,
    N_ICHANNELS
  };
public:
  enum {
    OCHANNEL_AUDIO_OUT,
    N_OCHANNELS
  };
protected:
  enum BassFilterPropertyID {
    PROP_CUTOFF_PERC = 1,
    PROP_RESO_PERC,
    PROP_ENV_MOD,
    PROP_ENV_DECAY,
    PROP_TRIGGER,
  };
public:
  /* "transport" structure to configure synthesis modules from properties */
  struct BassFilterProperties {
    typedef BassFilterPropertyID IDType;
    Sfi::Real cutoff_perc;
    Sfi::Real reso_perc;
    Sfi::Real env_mod;
    Sfi::Real env_decay;
    bool trigger;
    explicit BassFilterProperties (BassFilterBase *p) :
      cutoff_perc (p->cutoff_perc),
      reso_perc (p->reso_perc),
      env_mod (p->env_mod),
      env_decay (p->env_decay),
      trigger (p->trigger)
    {
    }
  };
protected:
  typedef ::Bse::SynthesisModule::NeedAutoUpdateTag AutoUpdateCategory;
protected:
  Sfi::Real cutoff_perc;
  guint64 last__cutoff_perc;
  Sfi::Real reso_perc;
  guint64 last__reso_perc;
  Sfi::Real env_mod;
  guint64 last__env_mod;
  Sfi::Real env_decay;
  guint64 last__env_decay;
  bool trigger;
public:
  void get_property (BassFilterPropertyID prop_id, ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_CUTOFF_PERC:
      sfi_value_set_real (&value, cutoff_perc);
    break;
    case PROP_RESO_PERC:
      sfi_value_set_real (&value, reso_perc);
    break;
    case PROP_ENV_MOD:
      sfi_value_set_real (&value, env_mod);
    break;
    case PROP_ENV_DECAY:
      sfi_value_set_real (&value, env_decay);
    break;
    case PROP_TRIGGER:
      sfi_value_set_bool (&value, trigger);
    break;
    };
  }
  void set_property (BassFilterPropertyID prop_id, const ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_CUTOFF_PERC:
      cutoff_perc = sfi_value_get_real (&value);
    break;
    case PROP_RESO_PERC:
      reso_perc = sfi_value_get_real (&value);
    break;
    case PROP_ENV_MOD:
      env_mod = sfi_value_get_real (&value);
    break;
    case PROP_ENV_DECAY:
      env_decay = sfi_value_get_real (&value);
    break;
    case PROP_TRIGGER:
      trigger = sfi_value_get_bool (&value);
    break;
    };
    property_changed (BassFilterPropertyID (prop_id));
    update_modules();
    switch (prop_id) {
    case PROP_TRIGGER:
      trigger = FALSE;
    break;
    default: ;
    };
  }
  virtual bool editable_property (BassFilterPropertyID prop_id, GParamSpec *pspec)
  {
    return true;
  }
  virtual void get_candidates (BassFilterPropertyID prop_id, ::Bse::PropertyCandidatesHandle &pch, GParamSpec *pspec)
  {
  }
  void property_updated (BassFilterPropertyID prop_id, guint64 tick_stamp, double prop_value, GParamSpec *pspec)
  {
    bool seen_change = false;
    switch (prop_id) {
    case PROP_CUTOFF_PERC:
      if (tick_stamp >= ::std::max (last__cutoff_perc, module_update_tick_stamp()))
        {
          seen_change = true;
          cutoff_perc = prop_value;
        }
      last__cutoff_perc = tick_stamp;
    break;
    case PROP_RESO_PERC:
      if (tick_stamp >= ::std::max (last__reso_perc, module_update_tick_stamp()))
        {
          seen_change = true;
          reso_perc = prop_value;
        }
      last__reso_perc = tick_stamp;
    break;
    case PROP_ENV_MOD:
      if (tick_stamp >= ::std::max (last__env_mod, module_update_tick_stamp()))
        {
          seen_change = true;
          env_mod = prop_value;
        }
      last__env_mod = tick_stamp;
    break;
    case PROP_ENV_DECAY:
      if (tick_stamp >= ::std::max (last__env_decay, module_update_tick_stamp()))
        {
          seen_change = true;
          env_decay = prop_value;
        }
      last__env_decay = tick_stamp;
    break;
    default: ;
    };
    if (seen_change &&
        property_changed (BassFilterPropertyID (prop_id)))
      update_modules();
  }
private:
  static struct StaticData {
    int dummy;
  } static_data;
protected:
  virtual bool property_changed (BassFilterPropertyID) { return false; }
  virtual ~BassFilterBase ()
  {
  }
public:
};


/* choice implementations */


/* record implementations */


/* sequence implementations */


/* class implementations */
void
BassFilterBase::class_init (::Bse::CxxBaseClass *klass)
{
  klass->set_accessors (::Bse::cxx_get_property_trampoline<BassFilterBase, BassFilterPropertyID>,
                        ::Bse::cxx_set_property_trampoline<BassFilterBase, BassFilterPropertyID>,
                        ::Bse::cxx_editable_property_trampoline<BassFilterBase, BassFilterPropertyID>,
                        ::Bse::cxx_get_candidates_trampoline<BassFilterBase, BassFilterPropertyID>,
                        ::Bse::cxx_property_updated_trampoline<BassFilterBase, BassFilterPropertyID>);
  klass->add_param (PROP_CUTOFF_PERC, sfidl_pspec_Perc (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/davbassfilter.idl",2673,"cutoff_perc",_ ( "Cutoff [%]" ) , _ ( "Set the cutoff frequency percentage" ) , 50LL , ":r:w:S:G:" ":automate:"));
  klass->add_param (PROP_RESO_PERC, sfidl_pspec_Perc (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/davbassfilter.idl",2674,"reso_perc",_ ( "Resonance [%]" ) , _ ( "Set the amount of resonance in percent" ) , 99.5 , ":r:w:S:G:" ":automate:"));
  klass->add_param (PROP_ENV_MOD, sfidl_pspec_Perc (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/davbassfilter.idl",2675,"env_mod",_ ( "Envelope Modulation [%]" ) , _ ( "Set the envelope magnitude in percent" ) , 90LL , ":r:w:S:G:" ":automate:"));
  klass->add_param (PROP_ENV_DECAY, sfidl_pspec_Perc (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/davbassfilter.idl",2676,"env_decay",_ ( "Decay [%]" ) , _ ( "Set the decay length in percent" ) , 20LL , ":r:w:S:G:" ":automate:"));
  klass->add_param (PROP_TRIGGER, sfidl_pspec_Trigger (_("Parameters"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/davbassfilter.idl",2677,"trigger",_ ( "Trigger filter" ) , NULL , ":r:w:G:"));
  klass->add_ichannel ("audio_in", _("Audio In"), _("Audio input"), ICHANNEL_AUDIO_IN);
  klass->add_ichannel ("trigger_in", _("Trigger In"), _("Trigger input"), ICHANNEL_TRIGGER_IN);
  klass->add_ochannel ("audio_out", _("Audio Out"), _("Filtered audio output"), OCHANNEL_AUDIO_OUT);
}


/* procedure implementations */


/* davbassfilter.idl type registrations */
#define BSE_CXX_REGISTER_ALL_TYPES_FROM_DAVBASSFILTER_IDL() \
  BSE_CXX_REGISTER_EFFECT (BassFilter); \
  /* davbassfilter.idl type registrations done */
} // Dav
} // Bse
template<bool> const unsigned char*
::Bse::Dav::BassFilterBase::inlined_pixstream()
{
  /* GdkPixbuf RGBA C-Source image dump 1-byte-run-length-encoded */

#ifdef __SUNPRO_C
#pragma align 4 (local_pixstream)
#endif
#ifdef __GNUC__
static const guint8 local_pixstream[] __attribute__ ((__aligned__ (4))) = 
#else
static const guint8 local_pixstream[] = 
#endif
{ ""
  /* Pixbuf magic (0x47646b50) */
  "GdkP"
  /* length: header (24) + pixel_data (8640) */
  "\0\0!\330"
  /* pixdata_type (0x2010002) */
  "\2\1\0\2"
  /* rowstride (256) */
  "\0\0\1\0"
  /* width (64) */
  "\0\0\0@"
  /* height (64) */
  "\0\0\0@"
  /* pixel_data: */
  "\307\0\0\0\0\202\0\0\0\1\207\0\0\0\2\204\0\0\0\3\207\0\0\0\2\202\0\0"
  "\0\1\250\0\0\0\0\6\0\0\0\1\0\0\0\3\0\0\0\5\0\0\0\7\0\0\0\10\0\0\0\11"
  "\205\0\0\0\12\204\0\0\0\13\205\0\0\0\12\6\0\0\0\11\0\0\0\10\0\0\0\7\0"
  "\0\0\5\0\0\0\3\0\0\0\1\244\0\0\0\0\11\0\0\0\1\0\0\0\2\0\0\0\5\0\0\0\11"
  "\0\0\0\15\0\0\0\22\0\0\0\26\0\0\0\31\0\0\0\33\206\0\0\0\34\1\0\0\0\35"
  "\205\0\0\0\34\11\0\0\0\33\0\0\0\31\0\0\0\26\0\0\0\22\0\0\0\15\0\0\0\11"
  "\0\0\0\5\0\0\0\2\0\0\0\1\242\0\0\0\0\11\0\0\0\2\0\0\0\6\0\0\0\14\0\0"
  "\0\24\0\0\0\36\0\0\0(\0\0\0""0\0\0\0""5\0\0\0""8\206\0\0\0:\1\0\0\0;"
  "\205\0\0\0:\11\0\0\0""8\0\0\0""5\0\0\0""0\0\0\0(\0\0\0\36\0\0\0\24\0"
  "\0\0\14\0\0\0\6\0\0\0\2\241\0\0\0\0\6\0\0\0\1\0\0\0\5\0\0\0\14\0\0\0"
  "\27\177\177\177Q\273\273\273\301\202\313\313\313\370\206\316\316\316"
  "\377\202\315\315\315\377\202\314\314\314\377\202\313\313\313\377\203"
  "\312\312\312\377\11\305\305\305\371\256\256\256\313[[[m\0\0\0""8\0\0"
  "\0'\0\0\0\27\0\0\0\14\0\0\0\5\0\0\0\1\237\0\0\0\0\6\0\0\0\1\0\0\0\3\0"
  "\0\0\11\0\0\0\25\177\177\177Q\314\314\314\367\204\316\316\316\377\202"
  "\315\315\315\377\202\314\314\314\377\203\313\313\313\377\202\312\312"
  "\312\377\202\311\311\311\377\202\310\310\310\377\203\307\307\307\377"
  "\10\302\302\302\371QQQz\0\0\0\77\0\0\0'\0\0\0\25\0\0\0\11\0\0\0\3\0\0"
  "\0\1\236\0\0\0\0\10\0\0\0\1\0\0\0\5\0\0\0\16\0\0\0\37\272\272\272\302"
  "\315\315\315\377\270\270\270\377\205\205\205\377\202iii\377\202eee\377"
  "\204ddd\377\205ccc\377\4fff\377\201\201\201\377\261\261\261\377\305\305"
  "\305\377\202\304\304\304\377\7\241\241\241\326\0\0\0Y\0\0\0""9\0\0\0"
  "\37\0\0\0\16\0\0\0\5\0\0\0\1\236\0\0\0\0\11\0\0\0\2\0\0\0\7\0\0\0\23"
  "\0\0\0)\314\314\314\377\313\313\313\377\204\204\204\377PPP\377\36\36"
  "\36\377\202\3\3\3\377\213\0\0\0\377\3\3\3\3\377'''\377\234\234\234\377"
  "\202\302\302\302\377\7\301\301\301\377\0\0\0q\0\0\0I\0\0\0)\0\0\0\23"
  "\0\0\0\7\0\0\0\2\236\0\0\0\0\4\0\0\0\2\0\0\0\11\0\0\0\27\0\0\0""1\202"
  "\311\311\311\377\2ddd\377\36\36\36\377\220\0\0\0\377\12AAA\377\306\306"
  "\306\377\300\300\300\377\277\277\277\377\0\0\0\202\0\0\0V\0\0\0""1\0"
  "\0\0\27\0\0\0\11\0\0\0\2\236\0\0\0\0\4\0\0\0\3\0\0\0\12\0\0\0\32\0\0"
  "\0""6\202\307\307\307\377\1bbb\377\222\0\0\0\377\11\324\324\324\377\276"
  "\276\276\377\275\275\275\377\0\0\0\215\0\0\0_\0\0\0""6\0\0\0\32\0\0\0"
  "\12\0\0\0\3\236\0\0\0\0\4\0\0\0\3\0\0\0\13\0\0\0\33\0\0\0""9\202\305"
  "\305\305\377\1aaa\377\222\0\0\0\377\11\335\335\335\377\274\274\274\377"
  "\273\273\273\377\0\0\0\223\0\0\0c\0\0\0""9\0\0\0\33\0\0\0\13\0\0\0\3"
  "\236\0\0\0\0\4\0\0\0\3\0\0\0\13\0\0\0\34\0\0\0;\202\303\303\303\377\1"
  "```\377\222\0\0\0\377\1\334\334\334\377\202\271\271\271\377\6\0\0\0\226"
  "\0\0\0e\0\0\0;\0\0\0\34\0\0\0\13\0\0\0\3\236\0\0\0\0\4\0\0\0\3\0\0\0"
  "\13\0\0\0\34\0\0\0;\202\301\301\301\377\1___\377\222\0\0\0\377\1\333"
  "\333\333\377\202\267\267\267\377\6\0\0\0\227\0\0\0f\0\0\0;\0\0\0\34\0"
  "\0\0\13\0\0\0\3\236\0\0\0\0\7\0\0\0\3\0\0\0\13\0\0\0\35\0\0\0;\277\277"
  "\277\377\276\276\276\377^^^\377\222p\217r\377\1\332\332\332\377\202\265"
  "\265\265\377\6\0\0\0\227\0\0\0f\0\0\0;\0\0\0\35\0\0\0\13\0\0\0\3\236"
  "\0\0\0\0\7\0\0\0\3\0\0\0\13\0\0\0\35\0\0\0;\275\275\275\377\274\274\274"
  "\377]]]\377\222\254\312\255\377\1\331\331\331\377\202\263\263\263\377"
  "\6\0\0\0\227\0\0\0g\0\0\0;\0\0\0\35\0\0\0\13\0\0\0\3\236\0\0\0\0\7\0"
  "\0\0\3\0\0\0\13\0\0\0\35\0\0\0;\273\273\273\377\272\272\272\377\\\\\\"
  "\377\203\300\336\301\377\206\0\0\0\377\1\300\336\301\377\204\0\0\0\377"
  "\1\216\244\217\377\203\300\336\301\377\10\330\330\330\377\261\261\261"
  "\377\260\260\260\377\0\0\0\227\0\0\0g\0\0\0;\0\0\0\35\0\0\0J\203\0\0"
  "\0\377\1\0\0\0B\203\0\0\0\0\1\0\0\0B\203\0\0\0\377\1\0\0\0B\203\0\0\0"
  "\0\1\0\0\0B\203\0\0\0\377\1\0\0\0B\213\0\0\0\0\7\0\0\0\3\0\0\0\13\0\0"
  "\0\35\0\0\0;\271\271\271\377\270\270\270\377[[[\377\203\300\336\301\377"
  "\206\0\0\0\377\1\300\336\301\377\205\0\0\0\377\203\300\336\301\377\7"
  "\327\327\327\377\257\257\257\377\256\256\256\377\0\0\0\227\0\0\0g\0\0"
  "\0;\0\0\0\35\205\0\0\0\377\202\0\0\0\0\1\0\0\0B\205\0\0\0\377\1\0\0\0"
  "B\202\0\0\0\0\205\0\0\0\377\213\0\0\0\0\4\0\0\0\3\0\0\0\13\0\0\0\35\0"
  "\0\0;\202\266\266\266\377\1ZZZ\377\205\300\336\301\377\202\0\0\0\377"
  "\203\300\336\301\377\202\0\0\0\377\3\300\336\301\377iyi\377\0\0\0\377"
  "\203\300\336\301\377\14\326\326\326\377\255\255\255\377\254\254\254\377"
  "\0\0\0\227\0\0\0g\0\0\0;\0\0\0\35\0\0\0\377\0\0\0u\0\0\0\0\0\0\0s\0\0"
  "\0\377\202\0\0\0\0\202\0\0\0\377\3\0\0\0s\0\0\0\0\0\0\0s\202\0\0\0\377"
  "\202\0\0\0\0\5\0\0\0\377\0\0\0s\0\0\0\0\0\0\0s\0\0\0\377\213\0\0\0\0"
  "\4\0\0\0\3\0\0\0\13\0\0\0\35\0\0\0;\202\264\264\264\377\1YYY\377\205"
  "\300\336\301\377\202\0\0\0\377\203\300\336\301\377\202\0\0\0\377\1\300"
  "\336\301\377\202\0\0\0\377\202\300\336\301\377\206\0\0\0\377\5\0\0\0"
  ";\0\0\0\35\0\0\0\13\0\0\0\3\0\0\0\0\202\0\0\0\377\202\0\0\0\0\202\0\0"
  "\0\377\203\0\0\0\0\202\0\0\0\377\205\0\0\0\0\202\0\0\0\377\213\0\0\0"
  "\0\4\0\0\0\3\0\0\0\13\0\0\0\35\0\0\0;\202\262\262\262\377\1XXX\377\205"
  "\300\336\301\377\202\0\0\0\377\203\300\336\301\377\202\0\0\0\377\1\300"
  "\336\301\377\202\0\0\0\377\202\300\336\301\377\206\0\0\0\377\5\0\0\0"
  ";\0\0\0\35\0\0\0\13\0\0\0\3\0\0\0\0\202\0\0\0\377\202\0\0\0\0\202\0\0"
  "\0\377\203\0\0\0\0\202\0\0\0\377\205\0\0\0\0\202\0\0\0\377\213\0\0\0"
  "\0\4\0\0\0\3\0\0\0\13\0\0\0\35\0\0\0;\202\260\260\260\377\1WWW\377\205"
  "\300\336\301\377\202\0\0\0\377\203\300\336\301\377\202\0\0\0\377\202"
  "\300\336\301\377\202\0\0\0\377\202\300\336\301\377\1\323\323\323\377"
  "\202\246\246\246\377\10\0\0\0\227\0\0\0f\0\0\0;\0\0\0\35\0\0\0\13\0\0"
  "\0\3\0\0\0\0\0\0\0B\202\0\0\0\377\1\0\0\0\0\202\0\0\0\377\203\0\0\0\0"
  "\202\0\0\0\377\205\0\0\0\0\1\0\0\0B\202\0\0\0\377\212\0\0\0\0\7\0\0\0"
  "\3\0\0\0\13\0\0\0\34\0\0\0;\256\256\256\377\255\255\255\377VVV\377\205"
  "\300\336\301\377\202\0\0\0\377\203\300\336\301\377\202\0\0\0\377\2\300"
  "\336\301\377iyi\377\202\0\0\0\377\202\300\336\301\377\1\322\322\322\377"
  "\202\244\244\244\377\3\0\0\0\226\0\0\0f\0\0\0;\202\0\0\0\377\3\0\0\0"
  "D\0\0\0\0\0\0\0B\202\0\0\0\377\1\0\0\0\0\202\0\0\0\377\3\0\0\0s\0\0\0"
  "\0\0\0\0s\202\0\0\0\377\1\0\0\0\0\202\0\0\0\377\3\0\0\0B\0\0\0\0\0\0"
  "\0B\202\0\0\0\377\212\0\0\0\0\7\0\0\0\3\0\0\0\13\0\0\0\34\0\0\0;\254"
  "\254\254\377\253\253\253\377ooo\377\205\300\336\301\377\202\0\0\0\377"
  "\203\300\336\301\377\206\0\0\0\377\202\300\336\301\377\1\321\321\321"
  "\377\202\242\242\242\377\4\0\0\0\225\0\0\0e\0\0\0:\0\0\0\34\205\0\0\0"
  "\377\3\0\0\0s\0\0\0\0\0\0\0B\205\0\0\0\377\1\0\0\0B\202\0\0\0\0\205\0"
  "\0\0\377\1\0\0\0s\212\0\0\0\0\7\0\0\0\3\0\0\0\13\0\0\0\33\0\0\0""9\252"
  "\252\252\377\251\251\251\377\230\230\230\377\205\300\336\301\377\202"
  "\0\0\0\377\203\300\336\301\377\205\0\0\0\377\4\216\244\217\377\300\336"
  "\301\377\263\321\264\377\313\313\313\377\202\240\240\240\377\5\0\0\0"
  "\221\0\0\0b\0\0\0""8\0\0\0\33\0\0\0I\203\0\0\0\377\1\0\0\0s\203\0\0\0"
  "\0\1\0\0\0B\203\0\0\0\377\1\0\0\0B\203\0\0\0\0\1\0\0\0B\203\0\0\0\377"
  "\1\0\0\0s\213\0\0\0\0\5\0\0\0\3\0\0\0\12\0\0\0\32\0\0\0""6\250\250\250"
  "\377\202\247\247\247\377\1\205\205\205\377\217\300\336\301\377\13\263"
  "\321\264\377\306\306\306\377\265\265\265\377\236\236\236\377\224\224"
  "\224\371\0\0\0\212\0\0\0\\\0\0\0""4\0\0\0\31\0\0\0\11\0\0\0\3\236\0\0"
  "\0\0\5\0\0\0\2\0\0\0\11\0\0\0\27\0\0\0""1\217\217\217\313\202\245\245"
  "\245\377\4\244\244\244\377\254\254\254\377\302\302\302\377\321\321\321"
  "\377\205\320\320\320\377\204\317\317\317\377\202\316\316\316\377\14\315"
  "\315\315\377\314\314\314\377\264\264\264\377\235\235\235\377\234\234"
  "\234\377YYY\321\0\0\0~\0\0\0R\0\0\0.\0\0\0\25\0\0\0\10\0\0\0\2\236\0"
  "\0\0\0\6\0\0\0\2\0\0\0\7\0\0\0\23\0\0\0)JJJm\240\240\240\371\203\242"
  "\242\242\377\202\241\241\241\377\202\240\240\240\377\202\237\237\237"
  "\377\203\236\236\236\377\202\235\235\235\377\202\234\234\234\377\203"
  "\233\233\233\377\11\232\232\232\377\221\221\221\371\12\12\12\225\0\0"
  "\0k\0\0\0D\0\0\0%\0\0\0\21\0\0\0\6\0\0\0\2\236\0\0\0\0\10\0\0\0\1\0\0"
  "\0\5\0\0\0\16\0\0\0\37\0\0\0""9AAAz\202\202\202\327\240\240\240\377\203"
  "\237\237\237\377\202\236\236\236\377\202\235\235\235\377\202\234\234"
  "\234\377\203\233\233\233\377\202\232\232\232\377\14\231\231\231\377\226"
  "\226\226\375\223\223\223\374XXX\321\12\12\12\225\0\0\0t\0\0\0S\0\0\0"
  "4\0\0\0\33\0\0\0\14\0\0\0\4\0\0\0\1\236\0\0\0\0\24\0\0\0\1\0\0\0\3\0"
  "\0\0\11\0\0\0\25\0\0\0'\0\0\0@\0\0\0]\0\0\0{\0\0\0\230\307\251\251\375"
  "\302\240\240\377\245ss\377yMM\377\3\2\2\322\0\0\0\301\0\0\0\261\0\0\0"
  "\244\0\0\0\234\0\0\0\230\0\0\0\227\202\0\0\0\226\13\0\0\0\224\0\0\0\221"
  "\0\0\0\212\0\0\0}\0\0\0k\0\0\0S\0\0\0""9\0\0\0#\0\0\0\22\0\0\0\10\0\0"
  "\0\2\240\0\0\0\0\22\0\0\0\1\0\0\0\5\0\0\0\14\0\0\0\30\0\0\0)\0\0\0\77"
  "\0\0\0Y\0\0\0v\303\244\244\366\306\250\250\377\253}}\377\200RR\377\14"
  "\13\13\304\0\0\0\246\0\0\0\216\0\0\0{\0\0\0o\0\0\0j\202\0\0\0g\14\0\0"
  "\0f\0\0\0e\0\0\0b\0\0\0\\\0\0\0R\0\0\0D\0\0\0""4\0\0\0#\0\0\0\24\0\0"
  "\0\12\0\0\0\4\0\0\0\1\202\0\0\0\0\202\0\0\0\1\207\0\0\0\2\204\0\0\0\3"
  "\207\0\0\0\2\202\0\0\0\1\211\0\0\0\0\22\0\0\0\2\0\0\0\6\0\0\0\14\0\0"
  "\0\27\0\0\0&\0\0\0;\0\0\0X\270\230\230\346\306\250\250\377\257\203\203"
  "\377\207WW\377\37\34\34\277\0\0\0\220\0\0\0q\0\0\0X\0\0\0H\0\0\0@\0\0"
  "\0=\202\0\0\0;\21\0\0\0:\0\0\0""8\0\0\0""4\0\0\0.\0\0\0%\0\0\0\33\0\0"
  "\0\21\0\0\0\12\0\0\0\5\0\0\0\2\0\0\0\1\0\0\0\2\0\0\0\3\0\0\0\5\0\0\0"
  "\7\0\0\0\10\0\0\0\11\205\0\0\0\12\204\0\0\0\13\205\0\0\0\12\6\0\0\0\11"
  "\0\0\0\10\0\0\0\7\0\0\0\5\0\0\0\3\0\0\0\1\207\0\0\0\0\22\0\0\0\1\0\0"
  "\0\2\0\0\0\5\0\0\0\13\0\0\0\26\0\0\0'\0\0\0C\247\205\205\314\303\241"
  "\241\377\260\204\204\377\212XX\3775++\306\0\0\0\202\0\0\0^\0\0\0@\0\0"
  "\0-\0\0\0#\0\0\0\37\202\0\0\0\35\22\0\0\0\34\0\0\0\33\0\0\0\30\0\0\0"
  "\25\0\0\0\21\0\0\0\14\0\0\0\7\0\0\0\4\0\0\0\2\0\0\0\1\0\0\0\2\0\0\0\5"
  "\0\0\0\11\0\0\0\15\0\0\0\22\0\0\0\26\0\0\0\31\0\0\0\33\206\0\0\0\34\1"
  "\0\0\0\35\205\0\0\0\34\11\0\0\0\33\0\0\0\31\0\0\0\26\0\0\0\22\0\0\0\15"
  "\0\0\0\11\0\0\0\5\0\0\0\2\0\0\0\1\206\0\0\0\0\32\0\0\0\1\0\0\0\2\0\0"
  "\0\5\0\0\0\15\0\0\0\33\0\0\0""4\222qq\251\302\240\240\377\266\215\215"
  "\377\226``\377R==\332\0\0\0\177\0\0\0Y\0\0\0""8\0\0\0\"\0\0\0\26\0\0"
  "\0\20\0\0\0\16\0\0\0\15\0\0\0\14\0\0\0\13\0\0\0\11\0\0\0\10\0\0\0\6\0"
  "\0\0\4\0\0\0\2\202\0\0\0\1\11\0\0\0\2\0\0\0\6\0\0\0\14\0\0\0\24\0\0\0"
  "\36\0\0\0(\0\0\0""0\0\0\0""5\0\0\0""8\206\0\0\0:\1\0\0\0;\205\0\0\0:"
  "\11\0\0\0""8\0\0\0""5\0\0\0""0\0\0\0(\0\0\0\36\0\0\0\24\0\0\0\14\0\0"
  "\0\6\0\0\0\2\210\0\0\0\0\37\0\0\0\2\0\0\0\10\0\0\0\24\0\0\0*gUUz\301"
  "\236\236\377\272\224\224\377\241nn\377sMM\364\0\0\0\204\0\0\0_\0\0\0"
  "=\0\0\0$\0\0\0\26\0\0\0\17\0\0\0\14\0\0\0\11\0\0\0\7\0\0\0\6\0\0\0\4"
  "\0\0\0\3\0\0\0\2\0\0\0\1\0\0\0\0\0\0\0\1\0\0\0\2\0\0\0\5\0\0\0\14\0\0"
  "\0\27\177\177\177Q\273\273\273\301\202\313\313\313\370\206\316\316\316"
  "\377\202\315\315\315\377\202\314\314\314\377\202\313\313\313\377\203"
  "\312\312\312\377\11\305\305\305\371\256\256\256\313[[[m\0\0\0""8\0\0"
  "\0'\0\0\0\27\0\0\0\14\0\0\0\5\0\0\0\1\207\0\0\0\0\26\0\0\0\1\0\0\0\5"
  "\0\0\0\17\0\0\0#\0\0\0C\274\231\231\371\274\230\230\377\252||\377\213"
  "YY\377)##\253\0\0\0n\0\0\0L\0\0\0""4\0\0\0$\0\0\0\33\0\0\0\26\0\0\0\21"
  "\0\0\0\14\0\0\0\10\0\0\0\5\0\0\0\2\0\0\0\1\202\0\0\0\0\6\0\0\0\1\0\0"
  "\0\3\0\0\0\11\0\0\0\25\177\177\177Q\314\314\314\367\204\316\316\316\377"
  "\202\315\315\315\377\202\314\314\314\377\203\313\313\313\377\202\312"
  "\312\312\377\202\311\311\311\377\202\310\310\310\377\203\307\307\307"
  "\377\10\302\302\302\371QQQz\0\0\0\77\0\0\0'\0\0\0\25\0\0\0\11\0\0\0\3"
  "\0\0\0\1\206\0\0\0\0\40\0\0\0\1\0\0\0\4\0\0\0\14\0\0\0\35\0\0\0:\237"
  "{{\307\274\230\230\377\262\210\210\377\233cc\377XBB\332\0\0\0\203\0\0"
  "\0g\0\0\0O\0\0\0@\0\0\0""5\0\0\0-\0\0\0$\0\0\0\33\0\0\0\22\0\0\0\13\0"
  "\0\0\6\0\0\0\2\0\0\0\1\0\0\0\0\0\0\0\1\0\0\0\5\0\0\0\16\0\0\0\37\272"
  "\272\272\302\315\315\315\377\270\270\270\377\205\205\205\377\202iii\377"
  "\202eee\377\204ddd\377\205ccc\377\4fff\377\201\201\201\377\261\261\261"
  "\377\305\305\305\377\202\304\304\304\377\7\241\241\241\326\0\0\0Y\0\0"
  "\0""9\0\0\0\37\0\0\0\16\0\0\0\5\0\0\0\1\207\0\0\0\0\40\0\0\0\3\0\0\0"
  "\11\0\0\0\27\0\0\0""1gTT\210\273\225\225\377\270\220\220\377\247ww\377"
  "\265\236\236\377\313\311\311\347\350\346\345\366\350\346\344\377\326"
  "\322\320\364\270\266\263\321\203\200~\223\0\0\0C\0\0\0""4\0\0\0%\0\0"
  "\0\30\0\0\0\15\0\0\0\6\0\0\0\3\0\0\0\1\0\0\0\2\0\0\0\7\0\0\0\23\0\0\0"
  ")\314\314\314\377\313\313\313\377\204\204\204\377PPP\377\36\36\36\377"
  "\202\3\3\3\377\213\0\0\0\377\3\3\3\3\377'''\377\234\234\234\377\202\302"
  "\302\302\377\7\301\301\301\377\0\0\0q\0\0\0I\0\0\0)\0\0\0\23\0\0\0\7"
  "\0\0\0\2\207\0\0\0\0\26\0\0\0\2\0\0\0\7\0\0\0\23\0\0\0)\0\0\0K\252\203"
  "\203\350\303\251\251\377\352\350\350\377\376\375\375\377\363\362\361"
  "\377\351\347\345\377\340\335\333\377\330\323\321\377\317\312\307\377"
  "\304\276\272\377\245\236\233\340EBAw\0\0\0A\0\0\0+\0\0\0\32\0\0\0\15"
  "\0\0\0\6\202\0\0\0\3\3\0\0\0\11\0\0\0\27\0\0\0""1\202\311\311\311\377"
  "\2ddd\377\36\36\36\377\220\0\0\0\377\12AAA\377\306\306\306\377\300\300"
  "\300\377\277\277\277\377\0\0\0\202\0\0\0V\0\0\0""1\0\0\0\27\0\0\0\11"
  "\0\0\0\2\207\0\0\0\0\33\0\0\0\1\0\0\0\6\0\0\0\20\0\0\0$\0\0\0D\224\177"
  "\177\270\370\367\367\377\376\375\375\377\360\356\355\377\341\336\334"
  "\377\326\321\317\377\317\312\307\377\316\311\306\377\316\310\305\377"
  "\305\300\274\377\266\256\251\377\236\226\220\365975\200\0\0\0E\0\0\0"
  "+\0\0\0\30\0\0\0\13\0\0\0\5\0\0\0\4\0\0\0\12\0\0\0\32\0\0\0""6\202\307"
  "\307\307\377\1bbb\377\222\0\0\0\377\11\324\324\324\377\276\276\276\377"
  "\275\275\275\377\0\0\0\215\0\0\0_\0\0\0""6\0\0\0\32\0\0\0\12\0\0\0\3"
  "\207\0\0\0\0\33\0\0\0\1\0\0\0\5\0\0\0\17\0\0\0\"\0\0\0B\344\344\344\340"
  "\376\375\375\377\353\351\347\377\331\324\322\377\315\310\305\377\313"
  "\305\302\377\302\274\270\377\336\332\330\377\352\350\347\377\326\323"
  "\321\377\263\254\247\377\242\227\221\377\177vp\345\0\0\0b\0\0\0A\0\0"
  "\0%\0\0\0\23\0\0\0\10\0\0\0\6\0\0\0\13\0\0\0\34\0\0\0""9\202\305\305"
  "\305\377\1aaa\377\222\0\0\0\377\11\335\335\335\377\274\274\274\377\273"
  "\273\273\377\0\0\0\223\0\0\0c\0\0\0""9\0\0\0\33\0\0\0\13\0\0\0\3\207"
  "\0\0\0\0\33\0\0\0\1\0\0\0\5\0\0\0\17\0\0\0$\261\261\261\213\376\375\375"
  "\377\360\356\355\377\331\325\323\377\314\306\303\377\303\275\271\377"
  "\310\302\276\377\276\267\262\377\351\347\346\377\366\365\365\377\332"
  "\331\330\377\233\226\222\377\243\232\223\377\214\200x\377FA>\257\0\0"
  "\0W\0\0\0""4\0\0\0\33\0\0\0\15\0\0\0\10\0\0\0\14\0\0\0\34\0\0\0;\202"
  "\303\303\303\377\1```\377\210\0\0\0\377\3q\220s\377\254\312\255\377p"
  "\217r\377\207\0\0\0\377\1\334\334\334\377\202\271\271\271\377\6\0\0\0"
  "\226\0\0\0e\0\0\0;\0\0\0\34\0\0\0\13\0\0\0\3\207\0\0\0\0\33\0\0\0\2\0"
  "\0\0\6\0\0\0\22\0\0\0(\341\340\340\314\363\362\361\377\341\336\334\377"
  "\316\311\306\377\303\275\271\377\300\271\264\377\303\275\270\377\275"
  "\266\261\377\326\322\320\377\332\331\330\377\265\263\261\377\205\200"
  "}\377\245\234\225\377\213\177w\377^WQ\341\0\0\0k\0\0\0C\0\0\0$\0\0\0"
  "\21\0\0\0\11\0\0\0\15\0\0\0\35\0\0\0;\202\301\301\301\377\1___\377\207"
  "\0\0\0\377\6q\220s\377\254\312\255\377\300\336\301\377\254\312\255\377"
  "p\217r\377\4\5\4\377\205\0\0\0\377\1\333\333\333\377\202\267\267\267"
  "\377\6\0\0\0\227\0\0\0f\0\0\0;\0\0\0\34\0\0\0\13\0\0\0\3\207\0\0\0\0"
  "\36\0\0\0\2\0\0\0\10\0\0\0\25\0\0\0-\354\352\351\362\351\347\345\377"
  "\327\322\320\377\306\300\274\377\300\271\264\377\276\267\262\377\277"
  "\270\263\377\273\264\257\377\270\261\255\377\236\231\225\377\207\202"
  "\177\377\215\207\203\377\244\233\224\377\211}u\377e]W\370\0\0\0|\0\0"
  "\0P\0\0\0-\0\0\0\25\0\0\0\13\0\0\0\16\0\0\0\35\0\0\0;\277\277\277\377"
  "\276\276\276\377^^^\377\206\0\0\0\377\3p\217r\377\225\275\227\377\237"
  "\305\241\377\202\300\336\301\377\2\240\305\242\377\226\276\230\377\205"
  "\0\0\0\377\1\332\332\332\377\202\265\265\265\377\6\0\0\0\227\0\0\0f\0"
  "\0\0;\0\0\0\35\0\0\0\13\0\0\0\3\207\0\0\0\0\36\0\0\0\2\0\0\0\11\0\0\0"
  "\27\0\0\0""1\350\346\344\377\340\335\333\377\317\312\307\377\307\302"
  "\276\377\307\301\274\377\302\274\270\377\274\265\260\377\272\262\255"
  "\377\267\257\252\377\266\256\251\377\264\254\246\377\257\247\241\377"
  "\242\231\222\377\204xp\377bYS\377\0\0\0\211\0\0\0\\\0\0\0""5\0\0\0\33"
  "\0\0\0\17\0\0\0\20\0\0\0\37\0\0\0=\275\275\275\377\274\274\274\377]]"
  "]\377\206p\217r\377\202\254\312\255\377\204\300\336\301\377\2\254\312"
  "\255\377IVJ\377\204\0\0\0\377\1\331\331\331\377\202\263\263\263\377\6"
  "\0\0\0\227\0\0\0g\0\0\0;\0\0\0\35\0\0\0\13\0\0\0\3\207\0\0\0\0\36\0\0"
  "\0\3\0\0\0\11\0\0\0\30\0\0\0""2\327\323\321\363\330\323\321\377\316\311"
  "\306\377\336\332\330\377\351\347\346\377\326\322\320\377\270\261\255"
  "\377\267\257\252\377\265\255\250\377\264\254\246\377\262\252\244\377"
  "\256\245\237\377\233\220\211\377xmf\377TLG\372\0\0\0\224\0\0\0g\0\0\0"
  "@\0\0\0$\0\0\0\26\0\0\0\25\0\0\0#\0\0\0@\273\273\273\377\272\272\272"
  "\377\\\\\\\377\206\254\312\255\377\210\300\336\301\377\1""5=5\377\203"
  "\0\0\0\377\11\330\330\330\377\261\261\261\377\260\260\260\377\0\0\0\227"
  "\0\0\0g\0\0\0;\0\0\0\35\0\0\0\13\0\0\0\3\207\0\0\0\0\36\0\0\0\2\0\0\0"
  "\10\0\0\0\27\0\0\0""1\271\266\263\320\316\311\306\377\316\310\305\377"
  "\352\350\347\377\366\365\365\377\332\331\330\377\236\231\225\377\266"
  "\256\251\377\264\254\246\377\262\252\244\377\257\247\241\377\245\234"
  "\225\377\216\202z\377g^W\377C=:\361\0\0\0\237\0\0\0u\0\0\0O\0\0\0""4"
  "\0\0\0$\0\0\0\"\0\0\0-\0\0\0H\271\271\271\377\270\270\270\377[[[\377"
  "\216\300\336\301\377\1\236\267\237\377\203\0\0\0\377\11\327\327\327\377"
  "\257\257\257\377\256\256\256\377\0\0\0\227\0\0\0g\0\0\0;\0\0\0\35\0\0"
  "\0\13\0\0\0\3\207\0\0\0\0\33\0\0\0\2\0\0\0\7\0\0\0\24\0\0\0+\204\201"
  "\177\222\303\275\271\377\305\300\274\377\326\323\320\377\332\331\330"
  "\377\265\263\261\377\207\202\177\377\264\254\246\377\262\252\244\377"
  "\257\247\241\377\251\240\232\377\227\214\205\377xmf\377WOI\377\223oo"
  "\377\205cc\337E;;\246\0\0\0g\0\0\0L\0\0\0=\0\0\0""8\0\0\0@\0\0\0W\202"
  "\266\266\266\377\1ZZZ\377\217\300\336\301\377\1""9B9\377\202\0\0\0\377"
  "\11\326\326\326\377\255\255\255\377\254\254\254\377\0\0\0\227\0\0\0g"
  "\0\0\0;\0\0\0\35\0\0\0\13\0\0\0\3\207\0\0\0\0\33\0\0\0\1\0\0\0\6\0\0"
  "\0\20\0\0\0$\0\0\0C\245\236\233\340\267\257\252\377\264\255\250\377\233"
  "\226\222\377\205\200}\377\216\210\203\377\257\247\241\377\256\245\237"
  "\377\246\235\226\377\231\216\207\377\201un\377_VP\377^RO\377\270\220"
  "\220\377\273\225\225\377\275\231\231\377\265\220\220\361\234xx\307\177"
  "dd\236WJJ\177+''o\13\12\12u\202\264\264\264\377\1YYY\377\217\300\336"
  "\301\377\1u\207v\377\202\0\0\0\377\11\325\325\325\377\253\253\253\377"
  "\252\252\252\377\0\0\0\227\0\0\0g\0\0\0;\0\0\0\35\0\0\0\13\0\0\0\3\207"
  "\0\0\0\0\11\0\0\0\1\0\0\0\4\0\0\0\14\0\0\0\33\0\0\0""4EBAw\237\227\221"
  "\365\242\227\221\377\243\232\223\377\202\245\234\225\377\20\242\231\222"
  "\377\234\221\213\377\216\202z\377yng\377_VP\377MEB\377\216cc\377\251"
  "yy\377\261\207\207\377\270\220\220\377\274\230\230\377\300\235\235\377"
  "\302\240\240\377\301\236\236\377\304\242\242\377\312\255\255\377\202"
  "\262\262\262\377\1XXX\377\217\300\336\301\377\1\237\270\240\377\202\0"
  "\0\0\377\1\324\324\324\377\202\250\250\250\377\6\0\0\0\227\0\0\0g\0\0"
  "\0;\0\0\0\35\0\0\0\13\0\0\0\3\210\0\0\0\0\32\0\0\0\2\0\0\0\10\0\0\0\22"
  "\0\0\0%\0\0\0A975\200\177vp\345\213\177w\377\212~v\377\211}u\377\203"
  "wo\377wle\377g^W\377WOI\377<73\364;21\342sOO\364\216[[\377\227aa\377"
  "\240ll\377\247ww\377\257\202\202\377\264\213\213\377\262\210\210\377"
  "\267\216\216\377\274\230\230\377\202\260\260\260\377\1WWW\377\217\300"
  "\336\301\377\1\267\324\270\377\202\0\0\0\377\1\323\323\323\377\202\246"
  "\246\246\377\6\0\0\0\227\0\0\0f\0\0\0;\0\0\0\35\0\0\0\13\0\0\0\3\210"
  "\0\0\0\0\26\0\0\0\1\0\0\0\4\0\0\0\13\0\0\0\30\0\0\0+\0\0\0E\0\0\0bFA"
  ">\257]VP\341d\\V\370aXR\377SKG\371>95\352$!\40\314\0\0\0\244\0\0\0\234"
  "\0\0\0\230/((\267YBB\334{OO\373\202TT\377\211WW\377\202\220]]\377\5\223"
  "__\377\234dd\377\256\256\256\377\255\255\255\377VVV\377\220\300\336\301"
  "\377\202\0\0\0\377\1\322\322\322\377\202\244\244\244\377\6\0\0\0\226"
  "\0\0\0f\0\0\0;\0\0\0\34\0\0\0\13\0\0\0\3\211\0\0\0\0\34\0\0\0\2\0\0\0"
  "\6\0\0\0\15\0\0\0\32\0\0\0+\0\0\0A\0\0\0W\0\0\0k\0\0\0{\0\0\0\205\0\0"
  "\0\210\0\0\0\206\0\0\0\177\0\0\0w\0\0\0o\0\0\0k\0\0\0m\0\0\0t\0\0\0}"
  "*$$\245C44\305S<<\334[\77\77\355dBB\367oGG\375\254\254\254\377\253\253"
  "\253\377ooo\377\220\300\336\301\377\3\0\0\0\377\20\20\20\377\321\321"
  "\321\377\202\242\242\242\377\6\0\0\0\225\0\0\0e\0\0\0:\0\0\0\34\0\0\0"
  "\13\0\0\0\3\211\0\0\0\0\34\0\0\0\1\0\0\0\2\0\0\0\6\0\0\0\15\0\0\0\30"
  "\0\0\0%\0\0\0""4\0\0\0C\0\0\0O\0\0\0W\0\0\0Z\0\0\0X\0\0\0R\0\0\0J\0\0"
  "\0D\0\0\0A\0\0\0D\0\0\0K\0\0\0T\0\0\0_\0\0\0j\0\0\0t\0\0\0\177\0\0\0"
  "\214\0\0\0\235\252\252\252\377\251\251\251\377\230\230\230\377\220\300"
  "\336\301\377\3\0\0\0\377lll\377\313\313\313\377\202\240\240\240\377\6"
  "\0\0\0\221\0\0\0b\0\0\0""8\0\0\0\33\0\0\0\12\0\0\0\3\212\0\0\0\0\31\0"
  "\0\0\1\0\0\0\2\0\0\0\6\0\0\0\13\0\0\0\22\0\0\0\33\0\0\0#\0\0\0+\0\0\0"
  "0\0\0\0""2\0\0\0""1\0\0\0-\0\0\0(\0\0\0#\0\0\0\"\0\0\0$\0\0\0)\0\0\0"
  "0\0\0\0""9\0\0\0C\0\0\0L\0\0\0W\0\0\0f\0\0\0{\250\250\250\377\202\247"
  "\247\247\377\1\205\205\205\377\217\300\336\301\377\13lll\377\306\306"
  "\306\377\265\265\265\377\236\236\236\377\224\224\224\371\0\0\0\212\0"
  "\0\0\\\0\0\0""4\0\0\0\31\0\0\0\11\0\0\0\3\213\0\0\0\0\30\0\0\0\1\0\0"
  "\0\2\0\0\0\4\0\0\0\7\0\0\0\13\0\0\0\20\0\0\0\23\0\0\0\26\0\0\0\27\0\0"
  "\0\26\0\0\0\24\0\0\0\21\0\0\0\17\0\0\0\16\0\0\0\17\0\0\0\22\0\0\0\27"
  "\0\0\0\35\0\0\0#\0\0\0+\0\0\0""4\0\0\0C\0\0\0Y\210\210\210\325\202\245"
  "\245\245\377\4\244\244\244\377\254\254\254\377\302\302\302\377\321\321"
  "\321\377\205\320\320\320\377\204\317\317\317\377\202\316\316\316\377"
  "\14\315\315\315\377\314\314\314\377\264\264\264\377\235\235\235\377\234"
  "\234\234\377YYY\321\0\0\0~\0\0\0R\0\0\0.\0\0\0\25\0\0\0\10\0\0\0\2\215"
  "\0\0\0\0\12\0\0\0\1\0\0\0\2\0\0\0\4\0\0\0\5\0\0\0\7\0\0\0\10\0\0\0\11"
  "\0\0\0\10\0\0\0\7\0\0\0\6\203\0\0\0\5\12\0\0\0\7\0\0\0\11\0\0\0\14\0"
  "\0\0\17\0\0\0\24\0\0\0\33\0\0\0'\0\0\0<BBBz\237\237\237\372\203\242\242"
  "\242\377\202\241\241\241\377\202\240\240\240\377\202\237\237\237\377"
  "\203\236\236\236\377\202\235\235\235\377\202\234\234\234\377\203\233"
  "\233\233\377\11\232\232\232\377\221\221\221\371\12\12\12\225\0\0\0k\0"
  "\0\0D\0\0\0%\0\0\0\21\0\0\0\6\0\0\0\2\217\0\0\0\0\202\0\0\0\1\205\0\0"
  "\0\2\205\0\0\0\1\13\0\0\0\2\0\0\0\3\0\0\0\5\0\0\0\10\0\0\0\14\0\0\0\26"
  "\0\0\0&\0\0\0\77@@@}\202\202\202\327\240\240\240\377\203\237\237\237"
  "\377\202\236\236\236\377\202\235\235\235\377\202\234\234\234\377\203"
  "\233\233\233\377\202\232\232\232\377\14\231\231\231\377\226\226\226\375"
  "\223\223\223\374XXX\321\12\12\12\225\0\0\0t\0\0\0S\0\0\0""4\0\0\0\33"
  "\0\0\0\14\0\0\0\4\0\0\0\1\235\0\0\0\0\15\0\0\0\1\0\0\0\2\0\0\0\5\0\0"
  "\0\13\0\0\0\27\0\0\0)\0\0\0@\0\0\0Z\0\0\0q\0\0\0\202\0\0\0\215\0\0\0"
  "\223\0\0\0\225\203\0\0\0\226\202\0\0\0\227\205\0\0\0\226\13\0\0\0\224"
  "\0\0\0\221\0\0\0\212\0\0\0}\0\0\0k\0\0\0S\0\0\0""9\0\0\0#\0\0\0\22\0"
  "\0\0\10\0\0\0\2\240\0\0\0\0\13\0\0\0\1\0\0\0\5\0\0\0\14\0\0\0\27\0\0"
  "\0'\0\0\0""8\0\0\0I\0\0\0V\0\0\0_\0\0\0c\0\0\0e\203\0\0\0f\202\0\0\0"
  "g\205\0\0\0f\13\0\0\0e\0\0\0b\0\0\0\\\0\0\0R\0\0\0D\0\0\0""4\0\0\0#\0"
  "\0\0\24\0\0\0\12\0\0\0\4\0\0\0\1\241\0\0\0\0\11\0\0\0\2\0\0\0\6\0\0\0"
  "\14\0\0\0\24\0\0\0\36\0\0\0(\0\0\0""0\0\0\0""5\0\0\0""8\204\0\0\0:\203"
  "\0\0\0;\204\0\0\0:\12\0\0\0""9\0\0\0""8\0\0\0""4\0\0\0.\0\0\0%\0\0\0"
  "\33\0\0\0\21\0\0\0\12\0\0\0\4\0\0\0\2\242\0\0\0\0\11\0\0\0\1\0\0\0\2"
  "\0\0\0\5\0\0\0\11\0\0\0\16\0\0\0\22\0\0\0\27\0\0\0\32\0\0\0\33\204\0"
  "\0\0\34\202\0\0\0\35\206\0\0\0\34\10\0\0\0\33\0\0\0\30\0\0\0\25\0\0\0"
  "\21\0\0\0\14\0\0\0\7\0\0\0\4\0\0\0\1\245\0\0\0\0\6\0\0\0\1\0\0\0\3\0"
  "\0\0\5\0\0\0\7\0\0\0\10\0\0\0\11\205\0\0\0\12\204\0\0\0\13\205\0\0\0"
  "\12\6\0\0\0\11\0\0\0\10\0\0\0\6\0\0\0\4\0\0\0\2\0\0\0\1\250\0\0\0\0\202"
  "\0\0\0\1\207\0\0\0\2\204\0\0\0\3\207\0\0\0\2\202\0\0\0\1\206\0\0\0\0"};



  return local_pixstream;
}

/*-------- end ../sfi/sfidl generated code --------*/


