
/*-------- begin ../sfi/sfidl generated code --------*/



#include <bse/bsecxxplugin.hh>


/* enum prototypes */


/* choice prototypes */


/* record prototypes */


/* sequence prototypes */


/* class prototypes */
namespace Bse {
namespace Standard {
class GusPatchEnvelopeBase;
class GusPatchEnvelope;
#define BSE_STANDARD_TYPE_GUS_PATCH_ENVELOPE		BSE_CXX_DECLARED_CLASS_TYPE (Bse::Standard, GusPatchEnvelope)
#define BSE_STANDARD_IS_GUS_PATCH_ENVELOPE(o) (::Bse::CxxBase::instance_is_a (o, BSE_STANDARD_TYPE_GUS_PATCH_ENVELOPE))


/* enum definitions */


/* sequence definitions */


/* record definitions */


/* enum declarations */


/* sequence type declarations */


/* record type declarations */


/* procedure prototypes */


/* class definitions */
BSE_CXX_DECLARE_CLASS (GusPatchEnvelope);
class GusPatchEnvelopeBase : public ::Bse::Effect {
public:
  static inline const unsigned char* pixstream () { return NULL; }
  static void               class_init (::Bse::CxxBaseClass *klass);
  static inline const char* options   () { return "unstable"; }
  static inline const char* category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules",  ("/Misc/StandardGusPatchEnvelope")); }
  static inline const char* i18n_category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules", _("/Misc/StandardGusPatchEnvelope")); }
  static inline const char* blurb     () { return _("StandardGusPatchEnvelope is an Envelope for GUS Patches\n\nGUS Patches contain different volume settings and tremolo settings for different notes, and the envelopes are of a non-standard form, thus using a BseWaveOsc alone is not enough to produce the sound of the GUS Patches; to accomplish the playing, you thus need to connect one (or for stereo two) BseWaveOsc(s) and their Gate Output Signal to this module."); }
  static inline const char* authors   () { return "Stefan Westerfeld"; }
  static inline const char* license   () { return _("GNU Lesser General Public License"); }
  static inline const char* type_name () { return "BseStandardGusPatchEnvelope"; }
public:
  enum {
    ICHANNEL_FREQUENCY,
    ICHANNEL_GATE_IN,
    ICHANNEL_RETRIGGER_IN,
    ICHANNEL_AUDIO_IN,
    ICHANNEL_AUDIO_GATE,
    N_ICHANNELS
  };
public:
  enum {
    OCHANNEL_AUDIO_OUT1,
    OCHANNEL_AUDIO_OUT2,
    OCHANNEL_DONE_OUT,
    N_OCHANNELS
  };
protected:
  enum GusPatchEnvelopePropertyID {
    PROP_WAVE = 1,
  };
public:
  /* "transport" structure to configure synthesis modules from properties */
  struct GusPatchEnvelopeProperties {
    typedef GusPatchEnvelopePropertyID IDType;
    BseWave* wave;
    explicit GusPatchEnvelopeProperties (GusPatchEnvelopeBase *p) :
      wave (p->wave)
    {
    }
  };
protected:
  typedef void AutoUpdateCategory;
protected:
  BseWave* wave;
public:
  void get_property (GusPatchEnvelopePropertyID prop_id, ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_WAVE:
      ::Bse::CxxBase::value_set_gobject (&value, wave);
    break;
    };
  }
  void set_property (GusPatchEnvelopePropertyID prop_id, const ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_WAVE:
      wave = ::Bse::CxxBase::value_get_gobject< BseWave> (&value);
    break;
    };
    property_changed (GusPatchEnvelopePropertyID (prop_id));
    update_modules();
    switch (prop_id) {
    default: ;
    };
  }
  virtual bool editable_property (GusPatchEnvelopePropertyID prop_id, GParamSpec *pspec)
  {
    return true;
  }
  virtual void get_candidates (GusPatchEnvelopePropertyID prop_id, ::Bse::PropertyCandidatesHandle &pch, GParamSpec *pspec)
  {
  }
  void property_updated (GusPatchEnvelopePropertyID prop_id, guint64 tick_stamp, double prop_value, GParamSpec *pspec)
  {
    bool seen_change = false;
    switch (prop_id) {
    default: ;
    };
    if (seen_change &&
        property_changed (GusPatchEnvelopePropertyID (prop_id)))
      update_modules();
  }
private:
  static struct StaticData {
    int dummy;
  } static_data;
protected:
  virtual bool property_changed (GusPatchEnvelopePropertyID) { return false; }
  virtual ~GusPatchEnvelopeBase ()
  {
  }
public:
};


/* choice implementations */


/* record implementations */


/* sequence implementations */


/* class implementations */
void
GusPatchEnvelopeBase::class_init (::Bse::CxxBaseClass *klass)
{
  klass->set_accessors (::Bse::cxx_get_property_trampoline<GusPatchEnvelopeBase, GusPatchEnvelopePropertyID>,
                        ::Bse::cxx_set_property_trampoline<GusPatchEnvelopeBase, GusPatchEnvelopePropertyID>,
                        ::Bse::cxx_editable_property_trampoline<GusPatchEnvelopeBase, GusPatchEnvelopePropertyID>,
                        ::Bse::cxx_get_candidates_trampoline<GusPatchEnvelopeBase, GusPatchEnvelopePropertyID>,
                        NULL);
  klass->add_param (PROP_WAVE, sfidl_pspec_TypedObject_default (_("Properties"),"/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/standardguspatchenvelope.idl",935, "wave", BSE_TYPE_WAVE));
  klass->add_ichannel ("frequency", _("Frequency"), _("Frequency Input"), ICHANNEL_FREQUENCY);
  klass->add_ichannel ("gate_in", _("Gate In"), _("Gate input (activates/deactivates envelope)"), ICHANNEL_GATE_IN);
  klass->add_ichannel ("retrigger_in", _("Retrigger In"), _("Retrigger input (raising edge retriggers envelope)"), ICHANNEL_RETRIGGER_IN);
  klass->add_ichannel ("audio_in", _("Audio In"), _("Audio Input of the WaveOsc playing the patch"), ICHANNEL_AUDIO_IN);
  klass->add_ichannel ("audio_gate", _("Audio Gate"), _("Gate Output of the WaveOsc playing the patch"), ICHANNEL_AUDIO_GATE);
  klass->add_ochannel ("audio_out1", _("Audio Out1"), _("Envelope audio output 1 (left output signal)"), OCHANNEL_AUDIO_OUT1);
  klass->add_ochannel ("audio_out2", _("Audio Out2"), _("Envelope audio output 2 (right output signal)"), OCHANNEL_AUDIO_OUT2);
  klass->add_ochannel ("done_out", _("Done Out"), _("This signal goes high after the release phase has completed"), OCHANNEL_DONE_OUT);
}


/* procedure implementations */


/* standardguspatchenvelope.idl type registrations */
#define BSE_CXX_REGISTER_ALL_TYPES_FROM_STANDARDGUSPATCHENVELOPE_IDL() \
  BSE_CXX_REGISTER_EFFECT (GusPatchEnvelope); \
  /* standardguspatchenvelope.idl type registrations done */
} // Standard
} // Bse

/*-------- end ../sfi/sfidl generated code --------*/


