
/*-------- begin ../sfi/sfidl generated code --------*/



#include <bse/bsecxxplugin.hh>


/* enum prototypes */
namespace Bse {
namespace Standard {
#define BSE_STANDARD_TYPE_SATURATION_TYPE		BSE_CXX_DECLARED_ENUM_TYPE (Bse::Standard, SaturationType)


/* choice prototypes */
static SfiChoiceValues SaturationType_choice_values();


/* record prototypes */


/* sequence prototypes */


/* class prototypes */
class SaturatorBase;
class Saturator;
#define BSE_STANDARD_TYPE_SATURATOR		BSE_CXX_DECLARED_CLASS_TYPE (Bse::Standard, Saturator)
#define BSE_STANDARD_IS_SATURATOR(o) (::Bse::CxxBase::instance_is_a (o, BSE_STANDARD_TYPE_SATURATOR))


/* enum definitions */
enum SaturationType {
  SATURATE_TANH = 0,
  SATURATE_ATAN = 1,
  SATURATE_QUADRATIC = 2,
  SATURATE_SOFT_KNEE = 3,
  SATURATE_HARD = 4,
};


/* sequence definitions */


/* record definitions */


/* enum declarations */
BSE_CXX_DECLARE_ENUM (SaturationType, "BseStandardSaturationType", 5,
  *v++ = ::Bse::EnumValue (SATURATE_TANH, "BSE_STANDARD_SATURATE_TANH", _("TANH") );
  *v++ = ::Bse::EnumValue (SATURATE_ATAN, "BSE_STANDARD_SATURATE_ATAN", _("ATAN") );
  *v++ = ::Bse::EnumValue (SATURATE_QUADRATIC, "BSE_STANDARD_SATURATE_QUADRATIC", _("Quadratic") );
  *v++ = ::Bse::EnumValue (SATURATE_SOFT_KNEE, "BSE_STANDARD_SATURATE_SOFT_KNEE", _("Soft Knee") );
  *v++ = ::Bse::EnumValue (SATURATE_HARD, "BSE_STANDARD_SATURATE_HARD", _("Hard") );
);


/* sequence type declarations */


/* record type declarations */


/* procedure prototypes */


/* class definitions */
BSE_CXX_DECLARE_CLASS (Saturator);
class SaturatorBase : public ::Bse::Effect {
  template<bool> static inline const unsigned char* inlined_pixstream();
public:
  static inline const unsigned char* pixstream () { return inlined_pixstream<true>(); }
  static void               class_init (::Bse::CxxBaseClass *klass);
  static inline const char* options   () { return ""; }
  static inline const char* category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules", "/Distortion/Saturate"); }
  static inline const char* i18n_category  () { static const char *c = NULL;
    return c ? c : c = sfi_category_concat ("/Modules", "/Distortion/Saturate"); }
  static inline const char* blurb     () { return "This is 2-channel saturation module. Various saturation types are supported. The 'Level' parameter adjusts the maximum saturation stage output for a normalized input signal. Some saturartion types simply clip signals beyond this threshold, while others (notably TANH and ATAN) allow overdrive signals to pass through the saturation stage up to a certain amount. The output volume allows for extra amplification after the saturation stage. For saturation types that allow overdrive signals past the saturation stage, an output volume greater than 0dB may result in overdrive signals as output of this module."; }
  static inline const char* authors   () { return "Tim Janik"; }
  static inline const char* license   () { return ""; }
  static inline const char* type_name () { return "BseStandardSaturator"; }
public:
  enum {
    ICHANNEL_AUDIO_IN1,
    ICHANNEL_AUDIO_IN2,
    N_ICHANNELS
  };
public:
  enum {
    OCHANNEL_AUDIO_OUT1,
    OCHANNEL_AUDIO_OUT2,
    N_OCHANNELS
  };
protected:
  enum SaturatorPropertyID {
    PROP_SATURATION = 1,
    PROP_LEVEL,
    PROP_AUTO_OUTPUT,
    PROP_OUTPUT_VOLUME,
  };
public:
  /* "transport" structure to configure synthesis modules from properties */
  struct SaturatorProperties {
    typedef SaturatorPropertyID IDType;
    ::Bse::Standard::SaturationType saturation;
    Sfi::Real level;
    bool auto_output;
    Sfi::Real output_volume;
    explicit SaturatorProperties (SaturatorBase *p) :
      saturation (p->saturation),
      level (p->level),
      auto_output (p->auto_output),
      output_volume (p->output_volume)
    {
    }
  };
protected:
  typedef ::Bse::SynthesisModule::NeedAutoUpdateTag AutoUpdateCategory;
protected:
  ::Bse::Standard::SaturationType saturation;
  Sfi::Real level;
  bool auto_output;
  Sfi::Real output_volume;
  guint64 last__output_volume;
public:
  void get_property (SaturatorPropertyID prop_id, ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_SATURATION:
      sfi_value_set_enum_auto SFI_START_ARGS() BSE_STANDARD_TYPE_SATURATION_TYPE, SFI_END_ARGS2 (&value, saturation);
    break;
    case PROP_LEVEL:
      sfi_value_set_real (&value, level);
    break;
    case PROP_AUTO_OUTPUT:
      sfi_value_set_bool (&value, auto_output);
    break;
    case PROP_OUTPUT_VOLUME:
      sfi_value_set_real (&value, output_volume);
    break;
    };
  }
  void set_property (SaturatorPropertyID prop_id, const ::Bse::Value &value, GParamSpec *pspec)
  {
    switch (prop_id) {
    case PROP_SATURATION:
      saturation = (::Bse::Standard::SaturationType) sfi_value_get_enum_auto SFI_START_ARGS() BSE_STANDARD_TYPE_SATURATION_TYPE, SFI_END_ARGS1 (&value);
    break;
    case PROP_LEVEL:
      level = sfi_value_get_real (&value);
    break;
    case PROP_AUTO_OUTPUT:
      auto_output = sfi_value_get_bool (&value);
    break;
    case PROP_OUTPUT_VOLUME:
      output_volume = sfi_value_get_real (&value);
    break;
    };
    property_changed (SaturatorPropertyID (prop_id));
    update_modules();
    switch (prop_id) {
    default: ;
    };
  }
  virtual bool editable_property (SaturatorPropertyID prop_id, GParamSpec *pspec)
  {
    return true;
  }
  virtual void get_candidates (SaturatorPropertyID prop_id, ::Bse::PropertyCandidatesHandle &pch, GParamSpec *pspec)
  {
  }
  void property_updated (SaturatorPropertyID prop_id, guint64 tick_stamp, double prop_value, GParamSpec *pspec)
  {
    bool seen_change = false;
    switch (prop_id) {
    case PROP_OUTPUT_VOLUME:
      if (tick_stamp >= ::std::max (last__output_volume, module_update_tick_stamp()))
        {
          seen_change = true;
          output_volume = prop_value;
        }
      last__output_volume = tick_stamp;
    break;
    default: ;
    };
    if (seen_change &&
        property_changed (SaturatorPropertyID (prop_id)))
      update_modules();
  }
private:
  static struct StaticData {
    int dummy;
  } static_data;
protected:
  virtual bool property_changed (SaturatorPropertyID) { return false; }
  virtual ~SaturatorBase ()
  {
  }
public:
};


/* choice implementations */
static SfiChoiceValues
SaturationType_choice_values()
{
  static SfiChoiceValue values[5];
  static const SfiChoiceValues choice_values = {
    G_N_ELEMENTS (values), values,
  };
  if (!values[0].choice_ident)
    {
      values[0].choice_ident = "BSE_STANDARD_SATURATE_TANH";
      values[0].choice_label = _("TANH");
      values[0].choice_blurb = _("Saturation via hyperbolic tangent function which is mostly linear for small levels while providing a soft curvature for high volume signals");
      values[1].choice_ident = "BSE_STANDARD_SATURATE_ATAN";
      values[1].choice_label = _("ATAN");
      values[1].choice_blurb = _("Saturation via arc tangent function which is reasonably linear in the lower 50% but develops a strong curvature above 80%");
      values[2].choice_ident = "BSE_STANDARD_SATURATE_QUADRATIC";
      values[2].choice_label = _("Quadratic");
      values[2].choice_blurb = _("Saturation via quadratic approximation which keeps a well-proportioned curvature across all levels");
      values[3].choice_ident = "BSE_STANDARD_SATURATE_SOFT_KNEE";
      values[3].choice_label = _("Soft Knee");
      values[3].choice_blurb = _("Linear saturation with a soft knee transit into the clipping range (equals hard clipping at 100%) which approaches quadratic curvature for small levels");
      values[4].choice_ident = "BSE_STANDARD_SATURATE_HARD";
      values[4].choice_label = _("Hard");
      values[4].choice_blurb = _("Hard saturation via clipping (prone to clicks)");
  }
  return choice_values;
}



/* record implementations */


/* sequence implementations */


/* class implementations */
void
SaturatorBase::class_init (::Bse::CxxBaseClass *klass)
{
  klass->set_accessors (::Bse::cxx_get_property_trampoline<SaturatorBase, SaturatorPropertyID>,
                        ::Bse::cxx_set_property_trampoline<SaturatorBase, SaturatorPropertyID>,
                        ::Bse::cxx_editable_property_trampoline<SaturatorBase, SaturatorPropertyID>,
                        ::Bse::cxx_get_candidates_trampoline<SaturatorBase, SaturatorPropertyID>,
                        ::Bse::cxx_property_updated_trampoline<SaturatorBase, SaturatorPropertyID>);
  klass->add_param (PROP_SATURATION, sfidl_pspec_GEnum ("Saturation","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/standardsaturator.idl",2689, "saturation", _ ( "Saturation Type" ) , _ ( "The type of saturation to be used" ) , SATURATE_TANH , ":r:w:S:G:", BSE_STANDARD_TYPE_SATURATION_TYPE));
  klass->add_param (PROP_LEVEL, sfidl_pspec_Perc ("Saturation","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/standardsaturator.idl",2690,"level",_ ( "Level" ) , _ ( "Normalization level of the saturation curve in percent, some saturation types still " "allow overdrive signals beyond this level" ) , 50LL , "scale:" ":r:w:S:G:"));
  klass->add_param (PROP_AUTO_OUTPUT, sfidl_pspec_Bool ("Saturation","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/standardsaturator.idl",2694,"auto_output",_ ( "Auto Output" ) , _ ( "Automatically adapt the output volume according to changes in saturation level" ) , TRUE , ":r:w:S:G:"));
  klass->add_param (PROP_OUTPUT_VOLUME, sfidl_pspec_DBVolume ("Saturation","/home/mandrake/rpm/BUILD/beast-0.7.1/plugins/standardsaturator.idl",2697,"output_volume",_ ( "Output Volume" ) , _ ( "Output stage amplification in decibel" ) , 0LL , 0LL , + 42LL , "automate:" ":r:w:S:G:"));
  klass->add_ichannel ("audio_in1", "Audio In1", "First Audio Input", ICHANNEL_AUDIO_IN1);
  klass->add_ichannel ("audio_in2", "Audio In2", "Second Audio Input", ICHANNEL_AUDIO_IN2);
  klass->add_ochannel ("audio_out1", "Audio Out1", "First Audio Output", OCHANNEL_AUDIO_OUT1);
  klass->add_ochannel ("audio_out2", "Audio Out2", "Second Audio Output", OCHANNEL_AUDIO_OUT2);
}


/* procedure implementations */


/* standardsaturator.idl type registrations */
#define BSE_CXX_REGISTER_ALL_TYPES_FROM_STANDARDSATURATOR_IDL() \
  BSE_CXX_REGISTER_ENUM (SaturationType); \
  BSE_CXX_REGISTER_EFFECT (Saturator); \
  /* standardsaturator.idl type registrations done */
} // Standard
} // Bse
template<bool> const unsigned char*
::Bse::Standard::SaturatorBase::inlined_pixstream()
{
  /* GdkPixbuf RGBA C-Source image dump 1-byte-run-length-encoded */

#ifdef __SUNPRO_C
#pragma align 4 (local_pixstream)
#endif
#ifdef __GNUC__
static const guint8 local_pixstream[] __attribute__ ((__aligned__ (4))) = 
#else
static const guint8 local_pixstream[] = 
#endif
{ ""
  /* Pixbuf magic (0x47646b50) */
  "GdkP"
  /* length: header (24) + pixel_data (5162) */
  "\0\0\24B"
  /* pixdata_type (0x2010002) */
  "\2\1\0\2"
  /* rowstride (256) */
  "\0\0\1\0"
  /* width (64) */
  "\0\0\0@"
  /* height (64) */
  "\0\0\0@"
  /* pixel_data: */
  "\206\0\0\0\0\230\0\0\0\1\243\0\0\0\0\3\0\0\0\1\0\0\0\4\0\0\0\10\202\0"
  "\0\0\13\230\0\0\0\14\5\0\0\0\13\0\0\0\12\0\0\0\10\0\0\0\3\0\0\0\1\236"
  "\0\0\0\0\5\0\0\0\4\0\0\0\17\0\0\0\36\0\0\0(\0\0\0*\230\0\0\0,\5\0\0\0"
  "*\0\0\0&\0\0\0\32\0\0\0\12\0\0\0\2\235\0\0\0\0\7\0\0\0\1\0\0\0\10\0\0"
  "\0\37\0\0\0;\0\0\0I\0\0\0J\0\0\0K\226\0\0\0L\6\0\0\0K\0\0\0I\0\0\0D\0"
  "\0\0.\0\0\0\20\0\0\0\2\235\0\0\0\0\6\0\0\0\1\0\0\0\13\0\0\0(\0\0\0I\0"
  "\0\0\270\0\0\0\343\230\0\0\0\377\5\12\27\12\377\33\77\33\377\0\0\0""8"
  "\0\0\0\23\0\0\0\2\235\0\0\0\0\7\0\0\0\1\0\0\0\14\0\0\0+\0\0\0J\0\0\0"
  "\343nnn\262\276\276\276\222\221\377\377\377\177\202&w&\377\11S\241R\377"
  "P\241P\377N\241M\377@\210\77\377+`,\377\12\27\12\377\0\0\0;\0\0\0\25"
  "\0\0\0\2\235\0\0\0\0\6\0\0\0\1\0\0\0\14\0\0\0,\0\0\0K\0\0\0\377\276\276"
  "\276\222\221\377\377\377\177\202&w&\377\12V\242U\377T\242R\377Q\241P"
  "\377N\241M\377K\240K\377>\211=\377\0\0\0\377\0\0\0<\0\0\0\26\0\0\0\2"
  "\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\221\377\377\377"
  "\177\202&w&\377\13X\242W\377V\242U\377T\242R\377Q\241P\377N\241M\377"
  "L\241K\377I\240I\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5"
  "\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\220\262\267\375\257\202&w&"
  "\377\14[\242Z\377Y\242X\377V\241U\377T\241S\377P\241P\377N\241N\377K"
  "\241K\377I\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0"
  "\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\217\226\235\374\313\202&w&\377"
  "\15^\242\\\377[\242Z\377X\241W\377V\241U\377T\241S\377Q\241P\377N\240"
  "N\377K\240K\377I\241H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0"
  "\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\216\226\235\374\313\202"
  "&w&\377\16`\243^\377^\242\\\377[\242Z\377Y\242W\377V\241U\377S\241R\377"
  "Q\241P\377N\241M\377L\241K\377H\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0"
  "\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\215\226"
  "\235\374\313\202&w&\377\17c\243a\377a\242_\377^\243]\377[\242Z\377Y\242"
  "W\377V\241T\377S\241R\377Q\241O\377N\241M\377L\240K\377H\240I\377\0\0"
  "\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,"
  "\0\0\0L\0\0\0\377\214\226\235\374\313\202&w&\377\20e\243d\377c\242a\377"
  "a\243_\377^\243]\377\\\242Z\377Y\241X\377U\241U\377T\241S\377P\241P\377"
  "N\241N\377K\240K\377H\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235"
  "\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\213\226\235\374\313"
  "\202&w&\377\21h\243g\377f\243d\377d\243b\377`\243_\377^\242\\\377[\242"
  "Z\377Y\242X\377V\242U\377S\241R\377P\241P\377N\241M\377K\241K\377I\240"
  "H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\4\0\0\0\1\0\0\0\14"
  "\0\0\0,\0\0\0L\234\0\0\0\377\3\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5"
  "\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\211\226\235\374\313\202&w&"
  "\377\23n\244k\377k\243h\377h\243f\377f\243d\377c\243a\377a\243_\377^"
  "\243\\\377\\\242Z\377Y\242X\377V\242U\377S\241S\377Q\241P\377N\241M\377"
  "K\240K\377H\240I\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5"
  "\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\210\226\235\374\313\202&w&"
  "\377\24p\245n\377m\244k\377k\244h\377h\244f\377f\243c\377c\243a\377a"
  "\243_\377^\243]\377[\242Z\377X\241W\377V\242U\377S\241S\377P\241P\377"
  "N\241M\377L\241K\377I\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235"
  "\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\207\226\235\374\313"
  "\202&w&\377\25s\245p\377q\244m\377n\244k\377k\243h\377i\243f\377f\243"
  "d\377d\243b\377a\242_\377]\243\\\377[\242Z\377Y\242W\377V\242U\377S\241"
  "S\377Q\241P\377N\241N\377L\240K\377H\240H\377\0\0\0\377\0\0\0=\0\0\0"
  "\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\206"
  "\226\235\374\313\202&w&\377\26v\245s\377s\244p\377q\244n\377n\244k\377"
  "l\244h\377i\243f\377e\243c\377c\243a\377`\242_\377^\242\\\377[\242Z\377"
  "Y\241W\377V\242U\377S\241S\377Q\241P\377N\240N\377K\241K\377I\240H\377"
  "\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0"
  "\0,\0\0\0L\0\0\0\377\205\226\235\374\313\202&w&\377\27x\245u\377v\245"
  "s\377t\245p\377p\244n\377n\244k\377k\244i\377i\244f\377f\243d\377c\243"
  "a\377a\242_\377]\243]\377[\242Y\377X\242W\377V\242U\377S\241R\377P\241"
  "P\377N\241N\377K\241K\377I\240I\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2"
  "\235\0\0\0\0\5\0\0\0\1\0\0\0\14\0\0\0,\0\0\0L\0\0\0\377\204\226\235\374"
  "\313\202&w&\377\30{\246x\377x\245u\377v\245s\377s\244p\377p\244n\377"
  "n\243k\377k\243i\377i\243f\377f\243c\377c\243b\377`\242_\377^\243]\377"
  "[\242Z\377Y\242X\377V\242U\377S\242S\377P\241P\377N\241N\377K\240K\377"
  "I\240H\377\0\0\0\377\0\0\0=\0\0\0\26\0\0\0\2\235\0\0\0\0\6\0\0\0\1\0"
  "\0\0\14\0\0\0,\0\0\0K\0\0\0\377{\201\317\323\202\226\235\374\313\202"
  "&w&\377\31~\246z\377{\245w\377y\245u\377v\244r\377s\245p\377q\245m\377"
  "n\244k\377k\244i\377i\243f\377f\244d\377d\243b\377`\243_\377]\242\\\377"
  "[\242Z\377X\242X\377U\241T\377S\242S\377Q\241O\377N\241M\377K\241K\377"
  ">\210>\377\0\0\0\377\0\0\0<\0\0\0\26\0\0\0\2\235\0\0\0\0\7\0\0\0\1\0"
  "\0\0\13\0\0\0+\0\0\0J\12\12\26\363RV\212\340{\201\317\323\202&w&\377"
  "\32\201\246|\377~\246z\377{\245w\377x\244u\377v\245r\377t\245p\377p\244"
  "n\377n\244k\377k\243i\377h\244f\377e\243c\377c\243a\377a\243_\377^\242"
  "]\377[\242Z\377X\242W\377V\242U\377S\241R\377Q\241O\377N\241N\377@\210"
  "@\377,`+\377\12\27\12\377\0\0\0:\0\0\0\24\0\0\0\2\235\0\0\0\0\6\0\0\0"
  "\1\0\0\0\12\0\0\0&\0\0\0E\36\40B\341\12\13\26\363\230\0\0\0\377\5\12"
  "\27\12\377\33\77\33\377\0\0\0""7\0\0\0\21\0\0\0\2\235\0\0\0\0\7\0\0\0"
  "\1\0\0\0\10\0\0\0\33\0\0\0.\0\0\0""8\0\0\0;\0\0\0<\223\0\0\0=\11\0\0"
  "\0>\0\0\0@\0\0\0D\0\0\0F\0\0\0G\0\0\0B\0\0\0+\0\0\0\14\0\0\0\1\236\0"
  "\0\0\0\5\0\0\0\3\0\0\0\12\0\0\0\20\0\0\0\23\0\0\0\24\223\0\0\0\26\12"
  "\0\0\0\27\0\0\0\31\0\0\0\34\0\0\0!\0\0\0&\0\0\0'\0\0\0$\0\0\0\26\0\0"
  "\0\7\0\0\0\1\236\0\0\0\0\1\0\0\0\1\227\0\0\0\2\11\0\0\0\3\0\0\0\4\0\0"
  "\0\6\0\0\0\10\0\0\0\12\3173\27\367\307+\23\364\0\0\0\27\0\0\0\5\272\0"
  "\0\0\0\12\0\0\0\1\3173\27\367\332=\34\377\331<\33\377\271'\21\343\0\0"
  "\0\34\0\0\0\3\302&\21\377\0\0\0\16\0\0\0\3\266\0\0\0\0\12\3173\27\344"
  "\332=\34\377\331<\33\377\330:\33\377\3248\31\376\263\40\16\350\302(\22"
  "\353\3140\26\377\0\0\0I\0\0\0\21\265\0\0\0\0\13\3204\27\360\332=\34\377"
  "\330<\33\377\327;\32\377\3269\32\377\3248\32\377\3237\31\377\3226\30"
  "\377\3130\25\377\0\0\0e\0\0\0\25\264\0\0\0\0\14\3204\30\352\332=\34\377"
  "\331<\33\377\327;\33\377\3269\32\377\3258\32\377\3236\31\377\3226\30"
  "\377\3215\30\377\312/\25\377\0\0\0j\0\0\0\25\264\0\0\0\0\14\307,\23\377"
  "\331<\33\377\330;\33\377\3269\32\377\3258\32\377\3237\31\377\3226\31"
  "\377\3214\30\377\3173\27\377\311.\25\377\0\0\0j\0\0\0\25\264\0\0\0\0"
  "\14\0\0\0\21\273(\21\352\3248\31\377\3248\32\377\3237\31\377\3226\31"
  "\377\3204\30\377\3173\27\377\3162\27\377\310-\24\377\0\0\0j\0\0\0\25"
  "\264\0\0\0\0\14\0\0\0\3\0\0\0\35\264\40\16\352\3236\31\377\3226\30\377"
  "\3215\30\377\3173\30\377\3162\27\377\3151\26\377\307,\23\377\0\0\0j\0"
  "\0\0\25\265\0\0\0\0\13\0\0\0\3\302(\22\353\3226\31\377\3214\30\377\317"
  "3\27\377\3161\27\377\3151\26\377\3140\25\377\306+\23\377\0\0\0j\0\0\0"
  "\25\265\0\0\0\0\13\303'\22\367\3141\26\377\313/\26\377\312.\25\377\311"
  ".\25\377\310-\24\377\307,\23\377\306+\23\377\302&\21\377\0\0\0j\0\0\0"
  "\25\265\0\0\0\0\3\0\0\0\15\0\0\0G\0\0\0d\202\0\0\0i\204\0\0\0j\2\0\0"
  "\0Y\0\0\0\22\265\0\0\0\0\6\0\0\0\3\0\0\0\20\0\0\0\25\0\0\0\30\0\0\0\36"
  "\0\0\0!\202\0\0\0#\6\0\0\0\"\0\0\0\34\0\0\0\14\0\0\0\6\0\0\0\4\0\0\0"
  "\3\225\0\0\0\2\1\0\0\0\1\236\0\0\0\0\14\0\0\0\3\0\0\0\20\0\0\0'\0\0\0"
  "7\0\0\0:\0\0\0;\0\0\0""9\0\0\0""3\0\0\0*\0\0\0!\0\0\0\32\0\0\0\27\221"
  "\0\0\0\26\5\0\0\0\24\0\0\0\22\0\0\0\20\0\0\0\12\0\0\0\3\236\0\0\0\0\14"
  "\0\0\0\5\0\0\0\32\0\0\0C\0\0\0\\\0\0\0_\0\0\0^\0\0\0]\0\0\0W\0\0\0N\0"
  "\0\0F\0\0\0@\0\0\0>\220\0\0\0=\7\0\0\0<\0\0\0;\0\0\0""8\0\0\0.\0\0\0"
  "\32\0\0\0\10\0\0\0\1\235\0\0\0\0\5\0\0\0\4\0\0\0\31\0\0\0D\0\0\0\272"
  "\0\0\0\344\230\0\0\0\377\6\0\0\0\342\0\0\0\266\0\0\0D\0\0\0&\0\0\0\12"
  "\0\0\0\1\235\0\0\0\0\6\0\0\0\3\0\0\0\27\0\0\0>\0\0\0\343nnn\262\276\276"
  "\276\222\226\377\377\377\177\7\276\276\276\222nnn\262\0\0\0\342\0\0\0"
  "I\0\0\0+\0\0\0\13\0\0\0\1\235\0\0\0\0\5\0\0\0\2\0\0\0\26\0\0\0<\0\0\0"
  "\377\276\276\276\222\230\377\377\377\177\6\276\276\276\222\0\0\0\377"
  "\0\0\0K\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0"
  "=\0\0\0\377\226\377\377\377\177\2\366\370\367\202\272\317\305\230\202"
  "\246\302\265\241\5\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0"
  "\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\222\262\267\375\257\15\257\265"
  "\372\260y\223\301\317U{\242\353Iq\233\367En\232\374Cl\232\377Eo\234\377"
  "Fo\235\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0"
  "\0\2\0\0\0\26\0\0\0=\0\0\0\377\220\226\235\374\313\17\201\220\342\327"
  "h\202\307\347Us\272\367Om\271\377Rp\276\377Wt\302\377Yw\304\377Zx\305"
  "\377Yx\304\377Xy\303\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235"
  "\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\216\226\235\374\313\21\177"
  "\220\340\327Wu\272\365Om\271\377Qo\274\377Ur\300\377Zv\305\377]y\307"
  "\377[y\306\377[y\305\377Zy\305\377Zy\304\377Xx\303\377\0\0\0\377\0\0"
  "\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0"
  "\0\377\215\226\235\374\313\6`|\300\355Nm\271\376Ro\274\377[v\305\377"
  "_y\311\377^y\310\377\202]y\307\377\12[y\306\377[y\305\377Zy\305\377Z"
  "x\304\377Xx\303\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0"
  "\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\214\226\235\374\313\4Vt\272"
  "\367Om\271\377Xt\303\377`y\312\377\202_y\311\377\2^y\310\377]y\310\377"
  "\202\\y\307\377\11[y\305\377Zy\305\377Yx\304\377Xx\303\377\0\0\0\377"
  "\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0"
  "=\0\0\0\377\213\226\235\374\313\5Rq\271\372Om\271\377]v\310\377ay\313"
  "\377`y\313\377\202_y\311\377\15^y\310\377]y\310\377]y\307\377[y\306\377"
  "[y\305\377Zy\305\377Yy\304\377Xx\303\377\0\0\0\377\0\0\0L\0\0\0,\0\0"
  "\0\14\0\0\0\1\235\0\0\0\0\3\0\0\0\2\0\0\0\26\0\0\0=\234\0\0\0\377\4\0"
  "\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0"
  "\0\0\377\211\226\235\374\313\202Om\271\377\2cz\315\377by\314\377\202"
  "ay\313\377\1`y\312\377\202_y\311\377\15^y\310\377]y\310\377]y\307\377"
  "[y\307\377[y\305\377Zy\305\377Yx\304\377Xx\303\377\0\0\0\377\0\0\0L\0"
  "\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377"
  "\210\226\235\374\313\202Om\271\377\6cz\316\377cz\315\377bz\314\377az"
  "\313\377ay\313\377`y\312\377\202_y\311\377\1^y\310\377\202]y\307\377"
  "\12[y\307\377[y\305\377Zy\305\377Zy\304\377Xx\303\377\0\0\0\377\0\0\0"
  "L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0"
  "\377\207\226\235\374\313\202Om\271\377\4ez\316\377dz\316\377cz\315\377"
  "by\314\377\202ay\313\377\1`y\313\377\202_y\311\377\1^y\310\377\202]y"
  "\307\377\12[y\307\377[y\305\377Zy\305\377Zx\304\377Xx\303\377\0\0\0\377"
  "\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0"
  "=\0\0\0\377\206\226\235\374\313\202Om\271\377\5fz\320\377ez\316\377d"
  "z\316\377cz\315\377cz\314\377\202ay\313\377\1`y\312\377\202_y\311\377"
  "\1^y\310\377\202]y\307\377\12[y\307\377[y\305\377Zx\305\377Yy\304\377"
  "Xx\303\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\4\0\0"
  "\0\2\0\0\0\26\0\0\0=\0\0\0\377\205\226\235\374\313\202Om\271\377\202"
  "fz\320\377\7ez\316\377cz\316\377cz\315\377bz\315\377az\313\377ay\313"
  "\377`y\312\377\202_y\311\377\1^y\310\377\202]y\307\377\12[y\306\377["
  "y\305\377Zy\305\377Yy\304\377Xx\303\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0"
  "\14\0\0\0\1\235\0\0\0\0\4\0\0\0\2\0\0\0\26\0\0\0=\0\0\0\377\204\226\235"
  "\374\313\202Om\271\377\1g{\321\377\202fz\320\377\4ez\316\377cz\316\377"
  "cy\315\377by\315\377\202ay\313\377\1`y\313\377\202_y\311\377\15^y\310"
  "\377]y\310\377]y\307\377[y\307\377[y\305\377Zy\305\377Yx\304\377Xx\303"
  "\377\0\0\0\377\0\0\0L\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\5\0\0\0\2\0"
  "\0\0\26\0\0\0<\0\0\0\377{\201\317\323\202\226\235\374\313\202Om\271\377"
  "\13h{\321\377gz\320\377fz\320\377fz\317\377ez\316\377dz\316\377cz\315"
  "\377bz\315\377ay\313\377az\313\377`y\313\377\202_y\311\377\15^y\310\377"
  "]y\310\377\\y\307\377[y\307\377[y\305\377Zy\305\377Yy\304\377Kf\246\377"
  "\0\0\0\377\0\0\0K\0\0\0,\0\0\0\14\0\0\0\1\235\0\0\0\0\6\0\0\0\2\0\0\0"
  "\24\0\0\0:\12\13\26\363RV\212\340{\201\317\323\202Om\271\377\14h{\322"
  "\377h{\321\377gz\320\377fz\320\377fz\317\377ez\316\377cz\316\377cz\315"
  "\377by\315\377az\313\377ay\313\377`y\312\377\202_y\311\377\1^y\310\377"
  "\202]y\307\377\12[y\306\377[y\305\377Zy\305\377Lf\247\3775Hu\377\14\21"
  "\34\377\0\0\0J\0\0\0+\0\0\0\14\0\0\0\1\235\0\0\0\0\5\0\0\0\2\0\0\0\22"
  "\0\0\0""8\36\40B\341\12\12\26\363\230\0\0\0\377\6\14\21\34\377\"/L\377"
  "\0\0\0H\0\0\0(\0\0\0\13\0\0\0\1\235\0\0\0\0\6\0\0\0\2\0\0\0\20\0\0\0"
  ".\0\0\0D\0\0\0I\0\0\0K\226\0\0\0L\7\0\0\0K\0\0\0J\0\0\0I\0\0\0;\0\0\0"
  "\37\0\0\0\10\0\0\0\1\235\0\0\0\0\5\0\0\0\2\0\0\0\12\0\0\0\32\0\0\0&\0"
  "\0\0*\230\0\0\0,\5\0\0\0*\0\0\0(\0\0\0\36\0\0\0\17\0\0\0\4\236\0\0\0"
  "\0\5\0\0\0\1\0\0\0\3\0\0\0\10\0\0\0\12\0\0\0\13\230\0\0\0\14\202\0\0"
  "\0\13\3\0\0\0\10\0\0\0\4\0\0\0\1\243\0\0\0\0\230\0\0\0\1\206\0\0\0\0"};



  return local_pixstream;
}

/*-------- end ../sfi/sfidl generated code --------*/


